/***************************************************************************
                          ktctool_delete.cpp  -  description
                             -------------------
    begin                : Fri Feb 1 2002
    copyright            : (C) 2002 by Vairo Raja
    email                : ktctool@fr.ee
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "ktctool.h"


// delete objects
void Ktctool::delshaperRules() {
    QString data, device, type, id, shaperfilterparent, shaperprio;

    delshaperqdisc.clearArguments();
    delshaperclass.clearArguments();
    delshaperfilter.clearArguments();

    data.sprintf(shaperdelinterfaceChoice);
    
  if (data != "") {

    int k = data.find(" "); data.remove(0,k+1);
    k = data.find(" ");
    device = data.left(k); data.remove(0,k+1);
    k = data.find(" ");
    type = data.left(k); data.remove(0,k+1);
    id = data;

  if (type.startsWith("f")) {
      k = id.find(" ");
      shaperfilterparent = id.left(k); id.remove(0,k+6);
      shaperprio = id.left(k);
      delshaperfilter << "tc" << "filter" << "del" << "dev" << device << "parent" << shaperfilterparent << "prio" << shaperprio;

      bool successfilter=delshaperfilter.start();
      if (successfilter) {
        statusbar->message(i18n("shaper filter deleted"), 2000);
        QString msg;
        msg.sprintf(i18n("shaper filter deleted for interface %s"), shaperdelinterfaceChoice);
        messageLog->insertItem(msg);
        addLog(delshaperfilter);
        tcdev = 0;
        listinfo.clear();
        subqdiscs.clear();
        startMonitorProcess(); // refresh window
      } else {
        statusbar->message(i18n("tc died"), 2000);
        QMessageBox::critical(0, "Error",
            i18n("filter has not been deleted, please check your parameters! \n"));
      }
  }


  if (type.startsWith("c")) {
     Tcobjects *objects;
     QString tcobject, parent;
     for ( objects=subqdiscs.first(); objects != 0; objects=subqdiscs.next() ) {
        parent.sprintf("%s", objects->id().latin1());
        if (parent == id) {
          QMessageBox::critical(0, "Error",
           i18n("Delete subqdisc(s) before deleting this class!"));
          parent = "no";
          break;
        }
     }
    if (parent != "no") {
      delshaperclass << "tc" << "class" << "del" << "dev" << device << "classid" << id;

      bool successclass=delshaperclass.start();
      if (successclass) {
        statusbar->message(i18n("class deleted"), 2000);
        QString msg;
        msg.sprintf(i18n("class deleted for interface %s"), shaperdelinterfaceChoice);
        messageLog->insertItem(msg);
        addLog(delshaperclass);
        tcdev = 0;
        listinfo.clear();
        subqdiscs.clear();
        startMonitorProcess(); // refresh window
      } else {
        statusbar->message(i18n("tc died"), 2000);
        QMessageBox::critical(0, "Error",
            i18n("class has not been deleted, please check your parameters! \n"));
      }
    }
  }


  if (type.startsWith("q")) {
     Tcobjects *objects;
     QString tcobject, tcobject2, parent;

   if (id == "ffff:") { //delete ingress
        delshaperqdisc << "tc" << "qdisc" << "del" << "dev" << device << "ingress";

      bool successqdisc=delshaperqdisc.start();
      if (successqdisc) {
        statusbar->message(i18n("qdisc deleted"), 2000);
        QString msg;
        msg.sprintf(i18n("qdisc deleted for interface %s"), shaperdelinterfaceChoice);
        messageLog->insertItem(msg);
        addLog(delshaperqdisc);
        tcdev = 0;
        listinfo.clear();
        subqdiscs.clear();
        startMonitorProcess(); // refresh window
      } else {
        statusbar->message(i18n("tc died"), 2000);
        QMessageBox::critical(0, "Error",
            i18n("qdisc has not been deleted, please check your parameters! \n"));
      }
   } else {   
     for ( objects=subqdiscs.first(); objects != 0; objects=subqdiscs.next() ) {
        tcobject.sprintf("%s", objects->type().latin1());
        parent.sprintf("%s", objects->id().latin1());
        if (tcobject == id) {   // this qdisc is subqdisc
          tcobject2 = parent;
          break;
        }
        if (parent == id) {
          QMessageBox::critical(0, "Error",
           i18n("Delete subqdisc(s) before deleting this!"));
          parent = "no";
          break;
        }
     }
    if (parent != "no") {
      if (tcobject2.find(":") > 0)
        delshaperqdisc << "tc" << "qdisc" << "del" << "dev" << device << "parent" << tcobject2;
      else
        delshaperqdisc << "tc" << "qdisc" << "del" << "dev" << device << "root";

      bool successqdisc=delshaperqdisc.start();
      if (successqdisc) {
        statusbar->message(i18n("qdisc deleted"), 2000);
        QString msg;
        msg.sprintf(i18n("qdisc deleted for interface %s"), shaperdelinterfaceChoice);
        messageLog->insertItem(msg);
        addLog(delshaperqdisc);
        tcdev = 0;
        listinfo.clear();
        subqdiscs.clear();      
        startMonitorProcess(); // refresh window
      } else {
        statusbar->message(i18n("tc died"), 2000);
        QMessageBox::critical(0, "Error",
            i18n("qdisc has not been deleted, please check your parameters! \n"));
      }
    }
    } // end else ingress
  }
 }
};


// select object to delete
void Ktctool::shaperdelinterfaceActivated(int index) {

  switch(index) {
  default:
    shaperdelinterfaceChoice = delobjects.at(1);
  case 0:
    shaperfilterinterfaceChoice = "";
    break;
  case 1:
    shaperdelinterfaceChoice = delobjects.at(1);
    break;
  case 2:
    shaperdelinterfaceChoice = delobjects.at(2);
    break;
  case 3:
    shaperdelinterfaceChoice = delobjects.at(3);
    break;
  case 4:
    shaperdelinterfaceChoice = delobjects.at(4);
    break;
  case 5:
    shaperdelinterfaceChoice = delobjects.at(5);
    break;
  case 6:
    shaperdelinterfaceChoice = delobjects.at(6);
    break;
  case 7:
    shaperdelinterfaceChoice = delobjects.at(7);
    break;
  case 8:
    shaperdelinterfaceChoice = delobjects.at(8);
    break;
  case 9:
    shaperdelinterfaceChoice = delobjects.at(9);
    break;
  case 10:
    shaperdelinterfaceChoice = delobjects.at(10);
    break;
  case 11:
    shaperdelinterfaceChoice = delobjects.at(11);
    break;
  case 12:
    shaperdelinterfaceChoice = delobjects.at(12);
    break;
  case 13:
    shaperdelinterfaceChoice = delobjects.at(13);
    break;
  case 14:
    shaperdelinterfaceChoice = delobjects.at(14);
    break;
  case 15:
    shaperdelinterfaceChoice = delobjects.at(15);
    break;
  case 16:
    shaperdelinterfaceChoice = delobjects.at(16);
    break;
  case 17:
    shaperdelinterfaceChoice = delobjects.at(17);
    break;
  case 18:
    shaperdelinterfaceChoice = delobjects.at(18);
    break;
  case 19:
    shaperdelinterfaceChoice = delobjects.at(19);
    break;
  case 20:
    shaperdelinterfaceChoice = delobjects.at(20);
    break;
  case 21:
    shaperdelinterfaceChoice = delobjects.at(21);
    break;
  case 22:
    shaperdelinterfaceChoice = delobjects.at(22);
    break;
  case 23:
    shaperdelinterfaceChoice = delobjects.at(23);
    break;
  case 24:
    shaperdelinterfaceChoice = delobjects.at(24);
    break;
  case 25:
    shaperdelinterfaceChoice = delobjects.at(25);
    break;
  };

};


// collect info about objects
void Ktctool::startdeleteShaper() {

//    if (xdelete == 0) { // first time click
//      xdelete++; x++;
//      startdeleteShaper();
//      TabWidget2->setCurrentPage(0);
//      return;
//    }
    
    listall.clear();
    subqdiscs.clear();
    tcaction = "all";
    tcfilter = "ok";
    tccommand.clearArguments();
    tccommand << "tc" << "qdisc" << "show";
    bool successtccommand=tccommand.start(KProcess::NotifyOnExit, KProcess::AllOutput);
    if (successtccommand == 0) {
      //QMessageBox::critical(0, "Message", i18n("Ktctool started"));
      startdeleteShaper();
    }

};


// delete objects
void Ktctool::deleteShaper() {

  QBoxLayout *top = new QBoxLayout(tab_four, QBoxLayout::LeftToRight, 10);
  QGridLayout *grid = new QGridLayout(10,10);
  top->addLayout(grid,10);

  QPushButton *btndelRefresh = new QPushButton(tab_four);
  btndelRefresh->setText(i18n("Refresh objects"));
  btndelRefresh->setFixedHeight(btndelRefresh->sizeHint().height());
  connect(btndelRefresh,SIGNAL(clicked()), this, SLOT(startdeleteShaper()));
  grid->addWidget(btndelRefresh,1,2);

  QLabel *labelbtndelRefresh = new QLabel(tab_four);
  labelbtndelRefresh->setText(i18n(" "));
  grid->addMultiCellWidget(labelbtndelRefresh,1,1,3,4,AlignRight);

  QLabel *labelshaperInterface = new QLabel(tab_four);
  labelshaperInterface->setText(i18n("Object:"));
  grid->addMultiCellWidget(labelshaperInterface,2,2,1,1,AlignRight);

  shaperdelinterface = new QComboBox( FALSE, tab_four, "object");
  shaperdelinterface->setFixedHeight(shaperdelinterface->sizeHint().height());
  connect(shaperdelinterface,SIGNAL(activated(int)), SLOT(shaperdelinterfaceActivated(int)));
  grid->addMultiCellWidget(shaperdelinterface,2,2,2,3);

  QPushButton *btndelShaper = new QPushButton(tab_four);
  btndelShaper->setText(i18n("Delete"));
  btndelShaper->setFixedHeight(btndelShaper->sizeHint().height());
  connect(btndelShaper,SIGNAL(clicked()), this, SLOT(delshaperRules()));
  grid->addWidget(btndelShaper,2,4); 
  
  QWhatsThis::add (shaperdelinterface, i18n("Delete selected object. Fastest way is to delete a qdisc, it deletes all subclasses and filters. \
You may not delete a class which is the parent of another class or which is bounded to a filter. Remember to delete subqdiscs before deleting parent."));
  QWhatsThis::add (btndelShaper, i18n("Delete selected object."));
  QWhatsThis::add (btndelRefresh, i18n("Refresh objects after you deleted something."));

  tab_four->show();
};
