/***************************************************************************
                          ktctool_filter.cpp  -  description
                             -------------------
    begin                : Fri Feb 1 2002
    copyright            : (C) 2002 by Vairo Raja
    email                : ktctool@fr.ee
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qbuttongroup.h>
#include <qradiobutton.h>

#include "ktctool.h"
    
// execute tc command line
void Ktctool::startfilterRules() {
    QString shaperprotocol, shaperprio, shaperclassid, shaperhandle, shaperroutenr, shaperu32match;
    QString shaperrate, shaperburst, shapermtu, shaperpeakrate, shaperavrate, shaperaction;
    QString shapertchash, shapertcmask, shapertcshift;
    QString data, device, id, start, id2, tcobject, found;
    QRegExp isprio = QRegExp("^[1-9][0-9]*$");
    bool successfilter;
    Tcobjects *objects;
       
    data.sprintf(shaperfilterinterfaceChoice);

  if (data != "") {

    device = data;
    
    if (tcingress_exec == 0) {
    if (listall.isEmpty()) {  // update listall
       startdeleteShaper();
       sleep(2);
    }
    // find parent id
    for ( objects=listall.first(); objects != 0; objects=listall.next() ) {
      tcobject.sprintf("%s", objects->dev().latin1());
      if (tcobject == device) {
      tcobject.sprintf("%s", objects->type().latin1());
      if (tcobject == "qdisc") {
        tcobject.sprintf("%s", objects->id().latin1());
        found = "";
        for ( objects=subqdiscs.first(); objects != 0; objects=subqdiscs.next() ) {
          id2.sprintf("%s", objects->type().latin1());
          if (tcobject == id2) {   // this qdisc is subqdisc
            found = "ok";
          }
        }
        if (found != "ok") {
          id = tcobject;
          break;
        }
      }
      } 
    }
    } else id = "ffff:";
    
    shaperprotocol.sprintf((const char *)(shaperfilterprotocol->text()));
    shaperprio.sprintf((const char *)(shaperfilterprio->text()));
    if (tcingress_exec == 1) shaperclassid = ":1";
    else shaperclassid = shaperfilterIdChoice;
    
    if(shaperclassid.length()==0 && tcingress_exec == 0) {
       QMessageBox::critical(0, "Error",
          i18n("You have to supply the class id! \n It indicates the class (X:Y) to go to if the packet matches the filter.\n"));
    } else {
      addshaperfilter.clearArguments();
      start = "yes";

      addshaperfilter << "tc" << "filter" << "add" << "dev" << device << "protocol" << shaperprotocol << "parent" << id;
      if (shaperprio.contains(isprio)) addshaperfilter << "prio" << shaperprio;
      else addshaperfilter << "prio" << "1";

      if (route_exec == 1) {
        shaperroutenr.sprintf((const char *)(shaperfilterroutenr->text()));
         if(shaperroutenr.length()==0) {
           QMessageBox::critical(0, "Error",
               i18n("You have to supply the realm! \n 'ip route add HOST/NETWORK via GATEWAY dev DEVICE realm REALMNUMBER'.\n Use this REALMNUMBER.\n"));
           start = "no";
        }
        addshaperfilter << "route" << shaperfilterrouteChoice << shaperroutenr << "flowid" << shaperclassid;

      } else if (u32_exec == 1) {
        shaperu32match.sprintf((const char *)(shaperfilterU32match->text()));
        if(shaperu32match.length()==0) {
           QMessageBox::critical(0, "Error",
               i18n("Match field is empty!\n View help about this filter.\n"));
           start = "no";
        }
        addshaperfilter << "u32" << "match" << shaperfilteru32Choice;
        int k;
        while (1) {
          k = shaperu32match.find(" ");
          if (k < 0) {
            addshaperfilter << shaperu32match;
            break;
          } else {
            data = shaperu32match.left(k);
            shaperu32match.remove(0,k+1);
            if (data != " ") addshaperfilter << data;
          }
        }
        
        addshaperfilter << "flowid" << shaperclassid;

      } else if (tci_exec == 1) {
          shapertchash.sprintf((const char *)(shaperfiltertchash->text()));
          shapertcmask.sprintf((const char *)(shaperfiltertcmask->text()));
          shapertcshift.sprintf((const char *)(shaperfiltertcshift->text()));
          shaperhandle.sprintf((const char *)(shaperfilterhandle->text()));

	        if ((shaperhandle.length()==0)||(shaperhandle.contains(" "))) {}
          else addshaperfilter << "handle" << shaperhandle;

          addshaperfilter << "tcindex";
	        if ((shapertchash.length()==0)||(shapertchash.contains(" "))) {}
          else addshaperfilter << "hash" << shapertchash;
	        if ((shapertcmask.length()==0)||(shapertcmask.contains(" "))) {}
          else addshaperfilter << "mask" << shapertcmask;
	        if ((shapertcshift.length()==0)||(shapertcshift.contains(" "))) {}
          else addshaperfilter << "shift" << shapertcshift;
          if (shaperfiltertcChoice == "pass_on")
              addshaperfilter << shaperfiltertcChoice;
          addshaperfilter << "classid" << shaperclassid;

      } else {
        shaperhandle.sprintf((const char *)(shaperfilterhandle->text()));

         if(shaperhandle.length()==0) {
           QMessageBox::critical(0, "Error",
               i18n("You have to supply the mark that the traffic shaper \n should use to count the packet for a reserved rate. \n e.g. 1 or 0x03 \n"));
           start = "no";
        }
        addshaperfilter << "handle" << shaperhandle << "fw" << "classid" << shaperclassid;
      }

        shaperrate.sprintf((const char *)(shaperfilterpolrate->text()));
        shaperburst.sprintf((const char *)(shaperfilterpolburst->text()));
        if ((shaperrate.length()!=0)||(shaperburst.length()!=0)) {  // add police info?
          if(shaperrate.length()==0) {
            QMessageBox::critical(0, "Error",
               i18n("Police rate field is empty! Police not created.\n"));   
          }
          else if(shaperburst.length()==0) {
            QMessageBox::critical(0, "Error",
               i18n("Police burst field is empty! Police not created.\n"));  
          }
          else {
            shapermtu.sprintf((const char *)(shaperfilterpolmtu->text()));
            shaperpeakrate.sprintf((const char *)(shaperfilterpolpeakrate->text()));
            shaperavrate.sprintf((const char *)(shaperfilterpolavrate->text()));
            shaperaction.sprintf(shaperfilteractionChoice);
            addshaperfilter << "police" << "rate" << shaperrate << "burst" << shaperburst;
            if(shapermtu.length()!=0) addshaperfilter << "mtu" << shapermtu;
            if(shaperpeakrate.length()!=0) addshaperfilter << "peakrate" << shaperpeakrate;
            if(shaperavrate.length()!=0) addshaperfilter << "avrate" << shaperavrate;
            addshaperfilter << "action" << shaperaction;
            
          }
        }
        if (start == "yes") {
        successfilter=addshaperfilter.start();
        if (successfilter) {
        } else {
          statusbar->message(i18n("tc died"), 2000);
          QMessageBox::critical(0, "Error",
               i18n("filter has not been created, please check your parameters! Maybe priority same.\n"));
        }
        } else {
          statusbar->message(i18n("tc died"), 2000);
          QMessageBox::critical(0, "Error",
               i18n("filter has not been created, please check your parameters! \n"));
        }
    }  // end shaperclassid
  }
};


// collect info about classes
void Ktctool::startfilterShaper() {

    listall.clear();
    subqdiscs.clear();
    tcaction = "all";
    tcfilter = "ok";
    tccommand.clearArguments();
    tccommand << "tc" << "qdisc" << "show";
    bool successtccommand=tccommand.start(KProcess::NotifyOnExit, KProcess::AllOutput);
    if (successtccommand == 0) {
      QMessageBox::critical(0, "Error",  i18n("Error: tc class show!"));
    }
};


// create filters
void Ktctool::trafficFilter() {
  
  QBoxLayout *top = new QBoxLayout(tab_three, QBoxLayout::LeftToRight, 10);
  QGridLayout * grid = new QGridLayout(10,11);
  top->addLayout(grid,11);

  QLabel *labelshaperInterface = new QLabel(tab_three);
  labelshaperInterface->setText( i18n("select interface:"));
  grid->addMultiCellWidget(labelshaperInterface,0,0,0,1,AlignRight);

  shaperfilterinterface = new QComboBox( FALSE, tab_three, "object");
  shaperfilterinterface->insertStrList(devices);
  shaperfilterinterface->setFixedHeight(shaperfilterinterface->sizeHint().height());
  connect(shaperfilterinterface,SIGNAL(activated(int)), SLOT(shaperfilterinterfaceActivated(int)));
  grid->addMultiCellWidget(shaperfilterinterface,0,0,2,2);

  QLabel *labelfilterprotocol = new QLabel(tab_three);
  labelfilterprotocol->setText( "protocol:");
  shaperfilterprotocol = new QLineEdit(tab_three);
  shaperfilterprotocol->setText("ip");
  grid->addMultiCellWidget(labelfilterprotocol,0,0,5,5,AlignRight);
  grid->addMultiCellWidget(shaperfilterprotocol,0,0,6,6);
    
  QLabel *labelclassid = new QLabel(tab_three);
  labelclassid->setText(i18n("class to send:"));

  shaperfilterclassId = new QComboBox( FALSE, tab_three, "object");
  shaperfilterclassId->setFixedHeight(shaperfilterclassId->sizeHint().height());
  connect(shaperfilterclassId,SIGNAL(activated(int)), SLOT(shaperfilterIdActivated(int)));

  grid->addMultiCellWidget(labelclassid,1,1,0,0,AlignRight);
  grid->addMultiCellWidget(shaperfilterclassId,1,1,1,1);

  QCheckBox *tcingress = new QCheckBox(i18n("ingress"), tab_three);
  tcingress->setAutoRepeat( FALSE );
  tcingress->setAutoResize( FALSE );
  connect(tcingress,SIGNAL(clicked()), this, SLOT(tcIngress2()));
  grid->addWidget(tcingress,1,2);
          
  QLabel *labelfilterprio = new QLabel(tab_three);
  labelfilterprio->setText( "choose priority:");

  shaperfilterprio = new QLineEdit(tab_three);
  shaperfilterprio->setFixedHeight(shaperfilterprio->sizeHint().height());
  shaperfilterprio->setText("1");

  grid->addMultiCellWidget(labelfilterprio,1,1,5,5,AlignRight);
  grid->addMultiCellWidget(shaperfilterprio,1,1,6,6);
  
  QLabel *labeltype = new QLabel(tab_three);
  labeltype->setText("   TYPE:");
  grid->addMultiCellWidget(labeltype,2,2,0,0,AlignRight);

  QRadioButton *b;
  QButtonGroup *bg;
  bg = new QButtonGroup( 0 );
  b = new QRadioButton( "fw", tab_three );
  grid->addMultiCellWidget(b,2,2,1,1,AlignRight);
  connect( b, SIGNAL(clicked()), this, SLOT(shaperfilterFw()) );
  bg->insert( b );
  b = new QRadioButton( "route", tab_three );
  grid->addMultiCellWidget(b,2,2,2,2,AlignRight);
  connect( b, SIGNAL(clicked()), this, SLOT(shaperfilterRoute()) );
  bg->insert( b );
  b = new QRadioButton( "u32", tab_three );
  grid->addMultiCellWidget(b,2,2,3,3,AlignRight);
  connect( b, SIGNAL(clicked()), this, SLOT(shaperfilterU32()) );
  bg->insert( b );
  b = new QRadioButton( "tcindex", tab_three );
  grid->addMultiCellWidget(b,2,2,4,4,AlignRight);
  connect( b, SIGNAL(clicked()), this, SLOT(shaperfilterTCI()) );
  bg->insert( b );

  btnfilter = new QPushButton(tab_three);
  btnfilter->setText( i18n("Create filter"));
  btnfilter->setFixedHeight(btnfilter->sizeHint().height());
//  connect(btnfilter,SIGNAL(clicked()), this, SLOT(slotEnableFilter()));
  connect(btnfilter,SIGNAL(clicked()), this, SLOT(startfilterRules()));
  grid->addWidget(btnfilter,2,6);
  
  QLabel *labelhandle = new QLabel(tab_three);
  labelhandle->setText( "handle:");
  shaperfilterhandle = new QLineEdit(tab_three);
  shaperfilterhandle->setFixedHeight(shaperfilterhandle->sizeHint().height());
  shaperfilterhandle->setText("");
  grid->addMultiCellWidget(labelhandle,3,3,1,1,AlignRight);
  grid->addMultiCellWidget(shaperfilterhandle,3,3,2,2);

  shaperfilterroute = new QComboBox( FALSE, tab_three, "route");
  shaperfilterroute ->insertItem("from");
  shaperfilterroute ->insertItem("to");
  shaperfilterroute ->setFixedHeight(shaperfilterroute ->sizeHint().height());
  connect(shaperfilterroute,SIGNAL(activated(int)), SLOT(shaperfilterrouteActivated(int)));
  grid->addMultiCellWidget(shaperfilterroute ,3,3,4,4);
// fromif TAG

  shaperfilterroutenr = new QLineEdit(tab_three);
  shaperfilterroutenr->setFixedHeight(shaperfilterroutenr->sizeHint().height());
  shaperfilterroutenr->setText("");
  grid->addMultiCellWidget(shaperfilterroutenr,3,3,5,5);

  QLabel *labelmatch = new QLabel(tab_three);
  labelmatch->setText("match");
  grid->addMultiCellWidget(labelmatch,4,4,0,0,AlignRight);

  shaperfilteru32 = new QComboBox( FALSE, tab_three, "u32");
  shaperfilteru32 ->insertItem("ip");
  shaperfilteru32 ->insertItem("ip6");
  shaperfilteru32 ->insertItem("udp");
  shaperfilteru32 ->insertItem("tcp");
  shaperfilteru32 ->insertItem("icmp");
  shaperfilteru32 ->insertItem("u8");
  shaperfilteru32 ->insertItem("u16");
  shaperfilteru32 ->insertItem("u32");
  shaperfilteru32 ->setFixedHeight(shaperfilteru32 ->sizeHint().height());
  connect(shaperfilteru32,SIGNAL(activated(int)), SLOT(shaperfilteru32Activated(int)));
  grid->addMultiCellWidget(shaperfilteru32 ,4,4,1,1);

   shaperfilterU32match = new QLineEdit(tab_three);
  shaperfilterU32match->setFixedHeight(shaperfilterU32match->sizeHint().height());
  shaperfilterU32match->setText("");
  grid->addMultiCellWidget(shaperfilterU32match,4,4,2,3);

/* [ link HTID ][ offset OFFSET_SPEC ]
   [ ht HTID ] [ hashkey HASHKEY_SPEC ]
   [ sample SAMPLE ]
  or u32 divisor DIVISOR  */

  QLabel *labelfiltertchash = new QLabel(tab_three);
  labelfiltertchash->setText( "hash:");

  shaperfiltertchash = new QLineEdit(tab_three);
  shaperfiltertchash->setFixedHeight(shaperfiltertchash->sizeHint().height());
  shaperfiltertchash->setText("");

  grid->addMultiCellWidget(labelfiltertchash,5,5,0,0,AlignRight);
  grid->addMultiCellWidget(shaperfiltertchash,5,5,1,1);

  QLabel *labelfiltertcmask = new QLabel(tab_three);
  labelfiltertcmask->setText( "mask:");

  shaperfiltertcmask = new QLineEdit(tab_three);
  shaperfiltertcmask->setFixedHeight(shaperfiltertcmask->sizeHint().height());
  shaperfiltertcmask->setText("");

  grid->addMultiCellWidget(labelfiltertcmask,5,5,2,2,AlignRight);
  grid->addMultiCellWidget(shaperfiltertcmask,5,5,3,3);

  QLabel *labelfiltertcshift = new QLabel(tab_three);
  labelfiltertcshift->setText( "shift:");

  shaperfiltertcshift = new QLineEdit(tab_three);
  shaperfiltertcshift->setFixedHeight(shaperfiltertcshift->sizeHint().height());
  shaperfiltertcshift->setText("");

  grid->addMultiCellWidget(labelfiltertcshift,5,5,4,4,AlignRight);
  grid->addMultiCellWidget(shaperfiltertcshift,5,5,5,5);

  shaperfiltertcfall = new QComboBox( FALSE, tab_three, "fall_through");
  shaperfiltertcfall ->insertItem("fall_through");
  shaperfiltertcfall ->insertItem("pass_on");
  shaperfiltertcfall ->setFixedHeight(shaperfiltertcfall ->sizeHint().height());
  connect(shaperfiltertcfall,SIGNAL(activated(int)), SLOT(shaperfilterTCIActivated(int)));
  grid->addMultiCellWidget(shaperfiltertcfall ,5,5,6,6);


  QLabel *labelpolice = new QLabel(tab_three);
  labelpolice->setText( i18n("police (optional)"));
  grid->addMultiCellWidget(labelpolice,7,7,0,0,AlignRight);
  QLabel *labelpolrate = new QLabel(tab_three);
  labelpolrate->setText("rate:");
  shaperfilterpolrate = new QLineEdit(tab_three);
  shaperfilterpolrate->setFixedHeight(shaperfilterpolrate->sizeHint().height());
  shaperfilterpolrate->setText("");
  grid->addMultiCellWidget(labelpolrate,7,7,1,1,AlignRight);
  grid->addMultiCellWidget(shaperfilterpolrate,7,7,2,2);

  QLabel *labelburst = new QLabel(tab_three);
  labelburst->setText("burst:");
  shaperfilterpolburst = new QLineEdit(tab_three);
  shaperfilterpolburst->setFixedHeight(shaperfilterpolburst->sizeHint().height());
  shaperfilterpolburst->setText("");
  grid->addMultiCellWidget(labelburst,7,7,3,3,AlignRight);
  grid->addMultiCellWidget(shaperfilterpolburst,7,7,4,4);

  QLabel *labelmtu = new QLabel(tab_three);
  labelmtu->setText("mtu:");
  shaperfilterpolmtu = new QLineEdit(tab_three);
  shaperfilterpolmtu->setFixedHeight(shaperfilterpolmtu->sizeHint().height());
  shaperfilterpolmtu->setText("");
  grid->addMultiCellWidget(labelmtu,7,7,5,5,AlignRight);
  grid->addMultiCellWidget(shaperfilterpolmtu,7,7,6,6);

  QLabel *labelpeakrate = new QLabel(tab_three);
  labelpeakrate->setText("peakrate:");
  shaperfilterpolpeakrate = new QLineEdit(tab_three);
  shaperfilterpolpeakrate->setFixedHeight(shaperfilterpolpeakrate->sizeHint().height());
  shaperfilterpolpeakrate->setText("");
  grid->addMultiCellWidget(labelpeakrate,8,8,1,1,AlignRight);
  grid->addMultiCellWidget(shaperfilterpolpeakrate,8,8,2,2);

  QLabel *labelavrate = new QLabel(tab_three);
  labelavrate->setText("avrate:");
  shaperfilterpolavrate = new QLineEdit(tab_three);
  shaperfilterpolavrate->setFixedHeight(shaperfilterpolavrate->sizeHint().height());
  shaperfilterpolavrate->setText("");
  grid->addMultiCellWidget(labelavrate,8,8,3,3,AlignRight);
  grid->addMultiCellWidget(shaperfilterpolavrate,8,8,4,4);

  QLabel *labelaction = new QLabel(tab_three);
  labelaction->setText("action:");
  grid->addMultiCellWidget(labelaction,8,8,5,5,AlignRight);
  shaperfilterpolaction = new QComboBox( FALSE, tab_three, "action");
  shaperfilterpolaction ->insertItem("drop");
  shaperfilterpolaction ->insertItem("continue");
  shaperfilterpolaction ->insertItem("reclassify");
  shaperfilterpolaction ->setFixedHeight(shaperfilterpolaction ->sizeHint().height());
  connect(shaperfilterpolaction,SIGNAL(activated(int)), SLOT(shaperfilterpolactionActivated(int)));
  grid->addMultiCellWidget(shaperfilterpolaction ,8,8,6,6);

  QWhatsThis::add (shaperfilterinterface, i18n("Select interface to add filter."));
  QWhatsThis::add (shaperfilterprotocol, i18n("Network protocol, usually ip or u8,u16,u32 (when using general selectors)."));
  QWhatsThis::add (shaperfilterprio, i18n("Filters with lower priority (1, ...) will be checked first. The priority is optional and defaults to one. \
 Recommended to set different priority to every filter. Set different priority if same parent and different filter."));
  QWhatsThis::add (shaperfilterclassId, i18n("It indicates the class (X: or X:Y) to go to if the packet matches the filter. This field is required. The \
target need not exist yet."));
  QWhatsThis::add (tcingress, i18n("Select if you wish to add this filter to the ingress qdisc."));
  
  QWhatsThis::add (shaperfilterhandle, i18n("Add fw filter. Bases the decision on how the firewall has marked the packet.\nIt is the mark the packet must have gotten from the firewall code (e.g. 1 or 0x4). The handle is required. \n This command marks all packets destined for port 25,\
outgoing mail:\n iptables -A PREROUTING -i eth0 -t mangle -p tcp --dport 25 -j MARK --set-mark 1\n Handle is also added to tcindex if this field is not empty when creating tcindex filter."));
  QWhatsThis::add (bg, i18n("fw bases the decision on how the firewall has marked the packet. \n route bases the decision on which route the packet will be routed by. \n \
//U32 can match on ANY part of a packet. \n  tcindex checks DS field "));

  QWhatsThis::add (shaperfilterroute, i18n("Bases the decision on which route the packet will be routed by. \n FROM: packets from the subnetwork xxx.xxx.xxx.xxx (realm NUMBER) will match class id CLASS ID.\n TO: packets going to the network xxx.xxx.xxx.xxx match class id CLASS ID."));
  QWhatsThis::add (shaperfilterroutenr, i18n("Define 'realm': 'ip route add HOST/NETWORK via GATEWAY dev DEVICE realm REALMNUMBER'.\n Use this REALMNUMBER (e.g. 1, 2, ...) here."));

  QWhatsThis::add (shaperfilteru32, i18n("Bases the decision on fields within the packet (i.e. source IP address, etc). \n Network protocol, usually ip."));
  QWhatsThis::add (shaperfilterU32match, i18n("Can match on ANY part of a packet. Examples based on ip. \n 1.) Source address 'src 1.2.3.0/24', destination address 'dst 4.3.2.0/24'. To match a single host, use /32, \
or omit the mask.\n 2.) Source port 'sport 80 0xffff', destination port 'dport 22 0xffff' \n 3.) Ip protocol 'protocol 1 0xff'. Use the numbers from /etc/protocols, e.g. icmp is 1. \n 4.) TOS field 'tos 0x10 0xff'\
 - interactive, minimum delay traffic. More help: PRIO priomap. \n\n General selectors:\n Using the general selectors you can match virtually any single bit in the IP (or upper layer) header. Syntax: \n match [ u32 | u16 | u8 ] PATTERN MASK\
 [ at OFFSET | nexthdr+OFFSET]\n u32, u16 or u8 specifies length of the pattern in bits. PATTERN and MASK should follow, of length defined by the previous keyword. The OFFSET parameter is the offset, in bytes, to start matching.\
 If nexthdr+ keyword is given, the offset is relative to start of the upper layer header. E.g. 'match u8 64 0xff at 8' (packet will match to this rule, if its time to live (TTL) is 64.)"));

  QWhatsThis::add (shaperfiltertchash, i18n("hash table size, value 1...0x10000. \n Tcindex example. root dsmark 1:0, cbq parent 1:0 handle 2:0, cbq class 2:1 ; Suppose we receive a packet marked as EF . This means that DS field (RFC2598) will be 10111000 (0xb8). Added filters:\n \
 tc filter add dev eth0 parent 1:0 protocol ip prio 1 tcindex mask 0xfc shift 2 \n tc filter add dev eth0 parent 2:0 protocol ip prio 1 handle 0x2e tcindex classid 2:1 pass_on \n Value1 = skb->tc_index & MASK \n Key = Value1 >> SHIFT \n \
Value1 = 10111000 & 11111100 = 10111000 (0xfc = 11111100) \n Key = 10111000 >> 2 = 00101110 -> 0x2E in hexadecimal \n The returned value will correspond to a qdisc internal filter handle (in the example, identifier 2:0). If a filter with this id exists, policing and metering \
conditions will be verified (in case that filter includes this) and the classid will be returned (in our example, classid 2:1) and stored in skb->tc_index variable."));
  QWhatsThis::add (shaperfiltertcmask, i18n("value 0...0xffff, default 0xffff"));
  QWhatsThis::add (shaperfiltertcshift, i18n("value 0...15, default 0"));
  QWhatsThis::add (shaperfiltertcfall, i18n("pass_on will be used to indicate that if no classid equal to the result of this filter is found, try next filter. \n fall_through - value key is returned as classid (if any filter with identifier is found)"));

  QWhatsThis::add (shaperfilterpolrate, i18n("<qt><b>Usually You don't need to add the police info.</b></qt>\nThe long-term rate attached to the meter (BPS). Required. \n\n You can have filters that only match up to a certain bandwidth. You can declare a filter to entirely cease matching above a certain rate, or only\
 to not match only the bandwidth exceeding a certain rate. If bandwidth exceeds the configured rate, you can drop a packet, reclassify it, or see if another filter will match it."));
  QWhatsThis::add (shaperfilterpolburst, i18n("This is the maximum amount of bytes that can be available for instantaneously. Required."));
  QWhatsThis::add (shaperfilterpolmtu, i18n("A packet exceeding this size will be dropped. The default value is 2KB."));
  QWhatsThis::add (shaperfilterpolpeakrate, i18n("This is the peakrate a flow is allowed to burst in the short-term. Basically this upper-bounds the rate (BPS)."));
  QWhatsThis::add (shaperfilterpolavrate, i18n("Average rate (BPS), take action if exceeded."));
  QWhatsThis::add (shaperfilterpolaction, i18n("This allows to define what actions should be exercised when a flow either exceeds its allocated or doesn't. \n drop - simply drops packet (PRIO ignores it) \n \
 continue - lookup the next filter rule with lower priority \n reclassify - most often comes down to reclassification to Best Effort \n\n You can have filters that only match up to a certain bandwidth. You can declare a filter to entirely cease\
 matching above a certain rate, or only to not match only the bandwidth exceeding a certain rate. If bandwidth exceeds the configured rate, you can drop a packet, reclassify it, or see if another filter will match it."));

  shaperfilterhandle->setEnabled(FALSE);
  shaperfilterroute->setEnabled(FALSE);
  shaperfilterroutenr->setEnabled(FALSE);
  shaperfilteru32->setEnabled(FALSE);
  shaperfilterU32match->setEnabled(FALSE);
  shaperfiltertchash->setEnabled(FALSE);
  shaperfiltertcmask->setEnabled(FALSE);
  shaperfiltertcshift->setEnabled(FALSE);
  shaperfiltertcfall->setEnabled(FALSE);
  btnfilter->setEnabled(FALSE);
  
  tab_three->show();

};


// menu widget choice device
void Ktctool::shaperfilterinterfaceActivated(int index) {

  switch(index) {
  default:
    shaperfilterinterfaceChoice = devices.at(0);
  case 0:
    shaperfilterinterfaceChoice = devices.at(0);
    break;
  case 1:
    shaperfilterinterfaceChoice = devices.at(1);
    break;
  case 2:
    shaperfilterinterfaceChoice = devices.at(2);
    break;
  case 3:
    shaperfilterinterfaceChoice = devices.at(3);
    break;
  case 4:
    shaperfilterinterfaceChoice = devices.at(4);
    break;
  case 5:
    shaperfilterinterfaceChoice = devices.at(5);
    break;
  case 6:
    shaperfilterinterfaceChoice = devices.at(6);
    break;
  case 7:
    shaperfilterinterfaceChoice = devices.at(7);
    break;
  case 8:
    shaperfilterinterfaceChoice = devices.at(8);
    break;
  };
  startclassShaper();
};


// route filter selection
void Ktctool::shaperfilterrouteActivated(int index) {

  switch(index) {
  default:
    shaperfilterrouteChoice = "from";
  case 0:
    shaperfilterrouteChoice = "from";
    break;
  case 1:
    shaperfilterrouteChoice = "to";
    break;
   };

};


// u32 filter selection
void Ktctool::shaperfilteru32Activated(int index) {

  switch(index) {
  default:
    shaperfilteru32Choice = "ip";
  case 0:
    shaperfilteru32Choice = "ip";
    break;
  case 1:
    shaperfilteru32Choice = "ip6";
    break;
  case 2:
    shaperfilteru32Choice = "udp";
    break;
  case 3:
    shaperfilteru32Choice = "tcp";
    break;
  case 4:
    shaperfilteru32Choice = "icmp";
    break;
  case 5:
    shaperfilteru32Choice = "u8";
    break;
  case 6:
    shaperfilteru32Choice = "u16";
    break;
  case 7:
    shaperfilteru32Choice = "u32";
    break;
   };

};


// filter tcindex selection
void Ktctool::shaperfilterTCIActivated(int index) {

  switch(index) {
  default:
    shaperfiltertcChoice = "fall_through";
  case 0:
    shaperfiltertcChoice = "fall_through";
    break;
  case 1:
    shaperfiltertcChoice = "pass_on";
    break;
   };

};


// police action selection
void Ktctool::shaperfilterpolactionActivated(int index) {

  switch(index) {
  default:
    shaperfilteractionChoice = "drop";
  case 0:
    shaperfilteractionChoice = "drop";
    break;
  case 1:
    shaperfilteractionChoice = "continue";
    break;
  case 2:
    shaperfilteractionChoice = "reclassify";
    break;
   };

};


// tcingress checkbox
void Ktctool::tcIngress2() {

  if (tcingress_exec==0)
    {
      tcingress_exec=1;
    }
  else
    {
      tcingress_exec=0;
    }
};

    
// fw filter
void Ktctool::shaperfilterFw() {

  route_exec=0;
  u32_exec=0;
  tci_exec=0;

  shaperfilterhandle->setEnabled(TRUE);
  shaperfilterroute->setEnabled(FALSE);
  shaperfilterroutenr->setEnabled(FALSE);
  shaperfilteru32->setEnabled(FALSE);
  shaperfilterU32match->setEnabled(FALSE);
  shaperfiltertchash->setEnabled(FALSE);
  shaperfiltertcmask->setEnabled(FALSE);  
  shaperfiltertcshift->setEnabled(FALSE);
  shaperfiltertcfall->setEnabled(FALSE);
  btnfilter->setEnabled(TRUE); 
};


// route filter
void Ktctool::shaperfilterRoute() {

   route_exec=1;
   u32_exec=0;
   tci_exec=0;
   
  shaperfilterhandle->setEnabled(FALSE);
  shaperfilterroute->setEnabled(TRUE);
  shaperfilterroutenr->setEnabled(TRUE);
  shaperfilteru32->setEnabled(FALSE);
  shaperfilterU32match->setEnabled(FALSE);
  shaperfiltertchash->setEnabled(FALSE);
  shaperfiltertcmask->setEnabled(FALSE);
  shaperfiltertcshift->setEnabled(FALSE);
  shaperfiltertcfall->setEnabled(FALSE);
  btnfilter->setEnabled(TRUE);
};


// u32 filter
void Ktctool::shaperfilterU32() {

   route_exec=0;
   u32_exec=1;
   tci_exec=0;
  shaperfilterhandle->setEnabled(FALSE);
  shaperfilterroute->setEnabled(FALSE);
  shaperfilterroutenr->setEnabled(FALSE);
  shaperfilteru32->setEnabled(TRUE);
  shaperfilterU32match->setEnabled(TRUE);
  shaperfiltertchash->setEnabled(FALSE);
  shaperfiltertcmask->setEnabled(FALSE);
  shaperfiltertcshift->setEnabled(FALSE);
  shaperfiltertcfall->setEnabled(FALSE);
  btnfilter->setEnabled(TRUE);  
};


// tcindex filter
void Ktctool::shaperfilterTCI() {

   route_exec=0;
   u32_exec=0;
   tci_exec=1;
  shaperfilterhandle->setEnabled(FALSE);
  shaperfilterroute->setEnabled(FALSE);
  shaperfilterroutenr->setEnabled(FALSE);
  shaperfilteru32->setEnabled(FALSE);
  shaperfilterU32match->setEnabled(FALSE);
  shaperfiltertchash->setEnabled(TRUE);
  shaperfiltertcmask->setEnabled(TRUE);
  shaperfiltertcshift->setEnabled(TRUE);
  shaperfiltertcfall->setEnabled(TRUE);
  btnfilter->setEnabled(TRUE);     
};


// select object to delete
void Ktctool::shaperfilterIdActivated(int index) {

  switch(index) {
  default:
    shaperfilterIdChoice = listclasses.at(0);
  case 0:
    shaperfilterIdChoice = listclasses.at(0);
    break;
  case 1:
    shaperfilterIdChoice = listclasses.at(1);
    break;
  case 2:
    shaperfilterIdChoice = listclasses.at(2);
    break;
  case 3:
    shaperfilterIdChoice = listclasses.at(3);
    break;
  case 4:
    shaperfilterIdChoice = listclasses.at(4);
    break;
  case 5:
    shaperfilterIdChoice = listclasses.at(5);
    break;
  case 6:
    shaperfilterIdChoice = listclasses.at(6);
    break;
  case 7:
    shaperfilterIdChoice = listclasses.at(7);
    break;
  case 8:
    shaperfilterIdChoice = listclasses.at(8);
    break;
  case 9:
    shaperfilterIdChoice = listclasses.at(9);
    break;
  case 10:
    shaperfilterIdChoice = listclasses.at(10);
    break;
  case 11:
    shaperfilterIdChoice = listclasses.at(11);
    break;
  case 12:
    shaperfilterIdChoice = listclasses.at(12);
    break;
  case 13:
    shaperfilterIdChoice = listclasses.at(13);
    break;
  case 14:
    shaperfilterIdChoice = listclasses.at(14);
    break;
  case 15:
    shaperfilterIdChoice = listclasses.at(15);
    break;
  case 16:
    shaperfilterIdChoice = listclasses.at(16);
    break;
  case 17:
    shaperfilterIdChoice = listclasses.at(17);
    break;
  case 18:
    shaperfilterIdChoice = listclasses.at(18);
    break;
  case 19:
    shaperfilterIdChoice = listclasses.at(19);
    break;
  case 20:
    shaperfilterIdChoice = listclasses.at(20);
    break;
  case 21:
    shaperfilterIdChoice = listclasses.at(21);
    break;
  case 22:
    shaperfilterIdChoice = listclasses.at(22);
    break;
  case 23:
    shaperfilterIdChoice = listclasses.at(23);
    break;
  case 24:
    shaperfilterIdChoice = listclasses.at(24);
    break;
  case 25:
    shaperfilterIdChoice = listclasses.at(25);
    break;
  };

};


// count filters
void Ktctool::filterExist(KProcess *, char *data, int len) {

  if (len<0)
    return;
  static QString remainder;
  QString list;
  QStrList lines;

  char dst[25000];
  memmove(dst,data,len);
  dst[len]=0;

  list=remainder+dst;

  int index=0;
  int newindex=0;
  sleep(2);
  while (1)
   {
    newindex=list.find('\n',index);
    if(newindex==-1) {
      remainder=list.right(list.length()-index);
      break;
    } else {
      lines.append(list.mid(index,newindex-index));
      index=newindex+1;
    };
  };
  filtercount = lines.count();

};


// do before adding filter
void Ktctool::slotEnableFilter() {
      filtercount = 0;
      filtercount2 = 0;
      filteradd.clearArguments();
      filteradd << "tc" << "filter" << "show" << "dev" << shaperfilterinterfaceChoice;
      filteradd.start(KProcess::NotifyOnExit, KProcess::AllOutput);
}


// do after adding filter
void Ktctool::slotEnableFilter1() {
      filtercount2 = filtercount;
      filteradd2.clearArguments();
      filteradd2 << "tc" << "filter" << "show" << "dev" << shaperfilterinterfaceChoice;
      filteradd2.start(KProcess::NotifyOnExit, KProcess::AllOutput);
}


// do after adding filter
void Ktctool::slotEnableFilter2() {
//     QString filterc;
//     filterc.sprintf("before %i", filtercount2);
//     QMessageBox::critical(0,"Warning", filterc);
//     filterc.sprintf("%i", filtercount);
//     QMessageBox::critical(0,"Warning", filterc);
                          
//     if (filtercount > filtercount2) {
//       statusbar->message(i18n("New shaper filter created"), 2000);
//       QString msg;
//       msg.sprintf(i18n("new shaper filter created for interface %s"), shaperfilterinterfaceChoice);
//       messageLog->insertItem(msg);
       addLog(addshaperfilter);
       tcdev = 0;
       listinfo.clear();
       subqdiscs.clear();
       startMonitorProcess(); // refresh window
//     } else {
//       statusbar->message(i18n("tc died"), 2000);
//       QMessageBox::critical(0, "Error",
//            i18n("filter has not been created, please check your parameters (maybe priority same)! \nOr temporary error, just refresh Qos Tree."));
//     }
};
