/***************************************************************************
                          ktctool_functions.cpp  -  description
                             -------------------
    begin                : Fri Feb 1 2002
    copyright            : (C) 2002 by Vairo Raja
    email                : ktctool@fr.ee
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <qcstring.h> 
#include <qevent.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qstringlist.h>
#include <qvaluelist.h>
#include <qvariant.h>

#include "ktctool.h"


// connecting created object 
void Ktctool::setupConnect() {

  KApplication::connect(&showqdisc,SIGNAL(receivedStdout(KProcess *, char *, int)),
      this,SLOT(shaperMonitor(KProcess *, char*, int)));
  KApplication::connect(&showqdisc,SIGNAL(receivedStderr(KProcess *, char *, int)),
      this,SLOT(shaperMonitor(KProcess *, char *, int)));


  KApplication::connect(&showclass,SIGNAL(receivedStdout(KProcess *, char *, int)),
      this,SLOT(shaperMonitor(KProcess *, char*, int)));
  KApplication::connect(&showclass,SIGNAL(receivedStderr(KProcess *, char *, int)),
      this,SLOT(shaperMonitor(KProcess *, char *, int)));


  KApplication::connect(&showfilter,SIGNAL(receivedStdout(KProcess *, char *, int)),
      this,SLOT(shaperMonitor(KProcess *, char*, int)));
  KApplication::connect(&showfilter,SIGNAL(receivedStderr(KProcess *, char *, int)),
      this,SLOT(shaperMonitor(KProcess *, char *, int)));


  KApplication::connect(&showip,SIGNAL(receivedStdout(KProcess *, char *, int)),
      this,SLOT(shaperMonitor(KProcess *, char*, int)));
  KApplication::connect(&showip,SIGNAL(receivedStderr(KProcess *, char *, int)),
      this,SLOT(shaperMonitor(KProcess *, char *, int)));

  KApplication::connect(&tccommand,SIGNAL(receivedStdout(KProcess *, char *, int)),
      this,SLOT(shaperCommand(KProcess *, char*, int)));
  KApplication::connect(&tccommand,SIGNAL(receivedStderr(KProcess *, char *, int)),
      this,SLOT(shaperMonitor(KProcess *, char *, int)));
  KApplication::connect(&tccommand,SIGNAL(processExited(KProcess *)),this,SLOT(slotEnable()));

  KApplication::connect(&tcexist,SIGNAL(receivedStdout(KProcess *, char *, int)),
      this,SLOT(shaperExist(KProcess *, char*, int)));
  KApplication::connect(&tcexist,SIGNAL(receivedStderr(KProcess *, char *, int)),
      this,SLOT(shaperMonitor(KProcess *, char *, int)));
  KApplication::connect(&tcexist,SIGNAL(processExited(KProcess *)),this,SLOT(shaperExistfinish()));

  KApplication::connect(&addshaperfilter,SIGNAL(processExited(KProcess *)),this,SLOT(slotEnableFilter2()));

// filter control
//  KApplication::connect(&filteradd,SIGNAL(receivedStdout(KProcess *, char *, int)),
//      this,SLOT(filterExist(KProcess *, char*, int)));
//  KApplication::connect(&filteradd,SIGNAL(processExited(KProcess *)),this,SLOT(startfilterRules()));
//   KApplication::connect(&addshaperfilter,SIGNAL(processExited(KProcess *)),this,SLOT(slotEnableFilter1()));
//  KApplication::connect(&filteradd2,SIGNAL(receivedStdout(KProcess *, char *, int)),
//      this,SLOT(filterExist(KProcess *, char*, int)));
//  KApplication::connect(&filteradd2,SIGNAL(processExited(KProcess *)),this,SLOT(slotEnableFilter2()));

         
//  KApplication::connect(&editlog,SIGNAL(receivedStderr(KProcess *, char *, int)),
//      this,SLOT(shaperMonitor(KProcess *, char *, int)));

};


// quitting
void Ktctool::closeEvent (QCloseEvent *) {

  kapp->quit();

};


// add command to log file
void Ktctool::addLog (KProcess &proce) {

   QCString msg;
   msg = "";
   typedef QValueList<QCString> Arguments;
   Arguments list = proce.args(); 

   for ( QValueList<QCString>::iterator it = list.begin(); it != list.end(); ++it ) {
       msg = msg + (*it) + " ";
   }
   msg.truncate(msg.length()-1);
   
   QFile f("/root/.ktctool.log");

   if ( f.open(IO_WriteOnly | IO_Append) ) {
      QTextStream t( &f );
      t << msg << "\n";
      f.close();
   } else
     messageLog->insertItem(i18n("Error writing to log file /root/.ktctool.log"));
}


// shows objects about a device
void Ktctool::startMonitorProcess() {

   tcaction = "info";
   tcfilter = "class";
   tccommand.clearArguments();
   
   tccommand << "tc" << "-d" << "qdisc" << "show" << "dev" << devices.at(tcdev);
   bool successtccommand=tccommand.start(KProcess::NotifyOnExit, KProcess::AllOutput);
  if (x < 1)  {
       x++;
       QMessageBox::information(0," ", "Ktctool started");
   }
   if (successtccommand == 0) {
         QMessageBox::information(0,"Warning", "Error reading information. Refresh QoS tree.");
   }
}


// refresh QoS Tree
void Ktctool::startRefresh() {
   tcdev = 0;
   listinfo.clear();
   subqdiscs.clear();
   startMonitorProcess(); // refresh window
}

              
// QoS Tree: add Qdisc
void Ktctool::addQdisc(QString info) {
  QString type, device, parent;

  parent = "";
  int k = info.find(" "); device = info.left(k); info.remove(0,k+1);
  uint tcdevice = 0;
  while (tcdevice < devices.count()) {
    QString dev = devices.at( tcdevice );
    if (device == dev) {
      shapermoninterface->setCurrentItem( tcdevice );
      shapermonitorinterfaceChoice = devices.at( tcdevice );
      break;
    }
    tcdevice++;
  }
  if (info.length() < 8) {  // add root qdisc
    type = info;
  } else {
    k = info.find(" "); info.remove(0,k+1); k = info.find(" "); type = info.left(k); info.remove(0,k+1);
    k = info.find(" "); parent = info.left(k); type = info.right(3);
  } 
  TabWidget2->setCurrentPage(1);
      if (type == "cbq") { // copy cbq info only, change not possible
        if (parent == "") shaperqdiscParent->setText("");
        else shaperqdiscParent->setText(parent);
        shaperMpu->setText("");
        shaperglobalBand->setText("100Mbit");
        shaperCell->setText("8");
        shaperEwma->setText("");
        shaperAvpkt->setText("1000");        
        shaperinterface->setCurrentItem(shapermoninterface->currentItem());
        shaperinterfaceChoice = shapermonitorinterfaceChoice;
        shaperqdiscHandle->setText("");
        
        tab_two->setCurrentPage(0);
     } else if (type == "dsmark") {
        dsmarkTcindex->setChecked(FALSE);
        dsmarkinterface->setCurrentItem(shapermoninterface->currentItem());
        dsmarkinterfaceChoice = shapermonitorinterfaceChoice;
        dsmarkqdiscHandle->setText("");
        dsmarkIndices->setText("");
        dsmarkDefaultIndex->setText("");
        tab_two->setCurrentPage(1);
     } else if (type == "pfifo" || type == "bfifo" || type == "ifo") {
        if (parent == "") pfifoqdiscParent->setText("");
        else pfifoqdiscParent->setText(parent);
        pfifointerface->setCurrentItem(shapermoninterface->currentItem());
        pfifointerfaceChoice = shapermonitorinterfaceChoice;
        pfifoqdiscHandle->setText("");
        pfifoNumber->setText("");
        tab_two->setCurrentPage(2);
     } else if (type == "prio") {       
        priointerface->setCurrentItem(shapermoninterface->currentItem());
        priointerfaceChoice = shapermonitorinterfaceChoice;        
        prioqdiscHandle->setText("");
        priobands->setText("3");
        priomap->setText("1 2 1 1  2 2 2 2  0 0 0 0  1 1 1 1");
        tab_two->setCurrentPage(3);
     } else if (type == "red") {
        if (parent == "") redqdiscParent->setText("");
        else redqdiscParent->setText(parent);
        redAvpkt->setText("1000");
        redBurst->setText("20");
        redProbability->setText("0.4");
        redglobalBand->setText("3Mbit");
        redLimit->setText("60KB");
        redMin->setText("15KB");
        redMax->setText("45KB");
        redinterface->setCurrentItem(shapermoninterface->currentItem());
        redinterfaceChoice = shapermonitorinterfaceChoice;
        redqdiscHandle->setText("");
        tab_two->setCurrentPage(4);
     } else if (type == "sfq") {
        if (parent == "") sfqqdiscParent->setText("");
        else sfqqdiscParent->setText(parent);
        sfqQuantum->setText("16450");
        sfqPerturb->setText("10");        
        sfqinterface->setCurrentItem(shapermoninterface->currentItem());
        sfqinterfaceChoice = shapermonitorinterfaceChoice;
        sfqqdiscHandle->setText("");
        tab_two->setCurrentPage(5);
     } else if (type == "tbf") {
        if (parent == "") tbfqdiscParent->setText("");
        else tbfqdiscParent->setText(parent);
        tbfLimit->setText("");
        tbfBurst->setText("");
        tbfPeakrate->setText("");
        tbfLatency->setText("");
        tbfMtu->setText("");
        tbfRate->setText("200kbit");
        tbfinterface->setCurrentItem(shapermoninterface->currentItem());
        tbfinterfaceChoice = shapermonitorinterfaceChoice;
        tbfqdiscHandle->setText("");
        tab_two->setCurrentPage(6);
     } else if (type == "ingress") {
        TabWidget2->setCurrentPage(4);
        shaperinterface->setCurrentItem(shapermoninterface->currentItem());
        shaperinterfaceChoice = shapermonitorinterfaceChoice;
        startingressQdisc();
     }           
}


// QoS Tree: add Filter
void Ktctool::addFilter(QString info) {
  QString device;
    
  int k = info.find(" ");
  if (k > 0) device = info.left(k);
  else device = info;
  uint tcdevice = 0;
  while (tcdevice < devices.count()) {
    QString dev = devices.at( tcdevice );
    if (device == dev) {
      shaperfilterinterface->setCurrentItem( tcdevice );
      shaperfilterinterfaceChoice = devices.at( tcdevice );
      break;
    }
    tcdevice++;
  }
  
  TabWidget2->setCurrentPage(2);
}


// QoS Tree: add Class
void Ktctool::addClass(QString info) {
  QString type, device;
  int isclass;
  
  isclass = info.find("class ");
  int k = info.find(" "); device = info.left(k); info.remove(0,k+1);
  uint tcdevice = 0;
  while (tcdevice < devices.count()) {
    QString dev = devices.at( tcdevice );
    if (device == dev) {
      shaperinterface->setCurrentItem( tcdevice );
      shaperinterfaceChoice = devices.at( tcdevice );
      break;
    }
    tcdevice++;
  }
  k = info.find(" "); info.remove(0,k+1);
  k = info.find(" "); info.remove(0,k+1); k = info.find(" "); type = info.left(k);
  
  shaperclassBounded->setChecked(FALSE);
  shaperclassIsolated->setChecked(FALSE);
  shaperclassSplit->setText("");
  shaperclassDefmap->setText("");
  shaperclassMaxburst->setText("20");
  shaperclassMinburst->setText("");
  shaperclassId->setText("");
  shaperparentHandle->setText(type);
  shaperclassAllot->setText("1514");
  
  if (isclass > 0) {
      k = info.find(" rate "); info.remove(0,k+6);
      k = info.find(" "); shaperrateBand->setText(info.left(k));
      k = info.find(" prio "); if (k > 0) { info.remove(0,k+6);  k = info.find("/");
          shaperclassPrio->setText(info.left(k)); }
      k = info.find(" weight "); if (k > 0) { info.remove(0,k+8);  k = info.find("bps");
          if (k < 0 || k > 10)  k = info.find(" ");
          shaperclassWeight->setText(info.left(k));  }
          
  } else {
      shaperrateBand->setText("8Mbit");
      shaperclassPrio->setText("6");
      shaperclassWeight->setText("0.8Mbit");
  }   
  TabWidget2->setCurrentPage(1);
  
}  


// collect info about classes (filter tab)
void Ktctool::startclassShaper() {
  
    if (x == 1) {  // first time click
      x++;
      startfilterShaper();
      TabWidget2->setCurrentPage(0);
      return;
    }
        
    listclasses.clear();
    tcaction = "classes";
    tccommand.clearArguments();
    tccommand << "tc" << "class" << "show" << "dev" << shaperfilterinterfaceChoice;
    bool successtccommand=tccommand.start(KProcess::NotifyOnExit, KProcess::AllOutput);
    if (successtccommand == 0) {
      //QMessageBox::critical(0, "Message", i18n("Ktctool started"));
      startclassShaper();
    }
};


// ingress qdisc
void Ktctool::ingressShaper() {

  QBoxLayout *top = new QBoxLayout(tab_five, QBoxLayout::LeftToRight, 10);
  QGridLayout *grid = new QGridLayout(10,10);
  top->addLayout(grid,10);

  QLabel *labelbtndelRefresh = new QLabel(tab_five);
  labelbtndelRefresh->setText(i18n(" Shape incoming traffic"));
  grid->addMultiCellWidget(labelbtndelRefresh,0,0,1,2,AlignRight);

	QLabel *labelshaperInterface = new QLabel(tab_five);
	labelshaperInterface->setText(i18n("Interface:"));
	grid->addMultiCellWidget(labelshaperInterface,1,1,1,1,AlignRight);

	shaperinterface = new QComboBox( FALSE, tab_five, "interface");
	shaperinterface->insertStrList(devices);
	shaperinterface->setFixedHeight(shaperinterface->sizeHint().height());
	connect(shaperinterface,SIGNAL(activated(int)), SLOT(shaperinterfaceActivated(int)));
	grid->addMultiCellWidget(shaperinterface,1,1,2,2);

  QPushButton *btndelShaper = new QPushButton(tab_five);
  btndelShaper->setText(i18n("Create ingress qdisc"));
  btndelShaper->setFixedHeight(btndelShaper->sizeHint().height());
  connect(btndelShaper,SIGNAL(clicked()), this, SLOT(startingressQdisc()));
  grid->addWidget(btndelShaper,1,3);

  QLabel *labelingress = new QLabel(tab_five);
  labelingress->setText(i18n("Add filters to ingress (check ingress on tab Create filter).\nFor example if you want to restrict the bandwidth 10KB from 192.168.10.0:\n\
select u32, match ip dst 192.168.10/24, police rate 80kbit, burst 10k (use dst 0/0 to match all incoming traffic)."));
  grid->addMultiCellWidget(labelingress,2,2,1,4,AlignRight);
  
  QWhatsThis::add (shaperinterface, i18n("Select network interface."));
  QWhatsThis::add (btndelShaper, i18n("Create ingress qdisc."));

  tab_five->show();
};


// if tc object exist
void Ktctool::startingressQdisc() {
  QString shaperinterface, tcid;

  startfunction = "ingressQdisc";
  shaperinterface.sprintf(shaperinterfaceChoice);
  tcid = "ffff:";
  QString tctype = "qdisc";
  startexistShaper(shaperinterface, tcid, tctype);

};

// create ingress qdisc
void Ktctool::createIngress() {
    QString shaperinterface;
    bool successqdisc=false;
    
    shaperinterface.sprintf(shaperinterfaceChoice);
    addshaperqdisc.clearArguments();
    addshaperqdisc << "tc" << "qdisc" << "add" << "dev" << shaperinterface << "ingress";

    if (tcexistid != "no")      // if don't exists
    successqdisc=addshaperqdisc.start();

  if (successqdisc) {
    statusbar->message(i18n("Ingress qdisc created"), 2000);
    QString msg;
    msg.sprintf( i18n("qdisc created for interface %s"), shaperinterfaceChoice);
    messageLog->insertItem(msg);
    addLog(addshaperqdisc);
    tcdev = 0;
    listinfo.clear();
    subqdiscs.clear();
    startMonitorProcess(); // refresh window
  } else {
    statusbar->message(i18n("tc died"), 2000);
    QMessageBox::critical(0, "Error",
       i18n("qdisc has not been created, please check your parameters! \n"));
  }    
};

                
// redefine middle mouse button
//void Ktctool::mousePressEvent(QMouseEvent *e) {

//  if (e->button() == QMouseEvent::LeftButton )
//    QWhatsThis::enterWhatsThisMode();

//};
