/***************************************************************************
                          ListViews_list.cpp  -  description
                             -------------------
    begin                : Fri Feb 1 2002
    copyright            : (C) 2002 by Vairo Raja
    email                : ktctool@fr.ee
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ktctool.h"


Folder::Folder( Folder *parent, const QString &name )
    : QObject( parent, name ), fName( name )
{

}


FolderListItem::FolderListItem( QListView *parent, Folder *f )
    : QListViewItem( parent )
{
    myFolder = f;
    QString type;

    setText( 1, f->folderName() );  // real info
    type = f->folderName();
    
    bool imageload;
    imageload = bluep.load("./blue.gif");
    if (imageload) {
       goldp.load("./gold.gif");
       redp.load("./red.gif");
    } else {
       bluep.load("/usr/local/kde/bin/blue.gif");
       goldp.load("/usr/local/kde/bin/gold.gif");
       redp.load("/usr/local/kde/bin/red.gif");
    }
    
    if (type.find("disc") > 0) { this->setPixmap( 0, bluep); }
    if (type.find("lass") > 0) { this->setPixmap( 0, goldp); }
    if (type.find("ilter") > 0) { this->setPixmap( 0, redp); }

    setText( 0, type );        
       
    if ( f->children() )
      insertSubFolders( myFolder->children() );
}

FolderListItem::FolderListItem( FolderListItem *parent, Folder *f )
    : QListViewItem( parent )
{
    myFolder = f;
    QString type;
    
    setText( 1, f->folderName() );  // real info
    type = f->folderName();

    bool imageload;
    imageload = bluep.load("./blue.gif");
    if (imageload) {
       goldp.load("./gold.gif");
       redp.load("./red.gif");
    } else {
       bluep.load("/usr/local/kde/bin/blue.gif");
       goldp.load("/usr/local/kde/bin/gold.gif");
       redp.load("/usr/local/kde/bin/red.gif");
    }
    if (type.find("disc") > 0) { this->setPixmap( 0, bluep); }
    if (type.find("lass") > 0) { this->setPixmap( 0, goldp); }
    if (type.find("ilter") > 0) { this->setPixmap( 0, redp); }

    type = makeShort( type );
    setText( 0, type );             // short info
        
    if ( myFolder->children() )
      insertSubFolders( myFolder->children() );
}

QString FolderListItem::makeShort(QString info) {
   QString info2, type;
   
   int k = info.find(" "); info.remove(0,k+1);
   k = info.find(" "); type = info.left(k); info.remove(0,k+1);
   if (type == "qdisc") {
      k = info.find(" "); info2 = info.left(k); info.remove(0,k+1);
      type = type + " " + info2 + " ";
      
      if (info2 == "cbq") {
         k = info.find(" rate "); k = info.find(" ", k+6);
         type = type + info.left(k);
      } else if (info2 == "dsmark") {
         type = type + info;
      } else if (info2 == "red") {
         k = info.find(" max "); k = info.find(" ", k+6);
         type = type + info.left(k);
      } else if (info2 == "sfq") {
        k = info.find("quantum "); k = info.find(" ", k+9);
        type = type + info.left(k); info.remove(0,k+1);
        k = info.find(" perturb "); info.remove(0,k);
        type = type + info.left(k);
      } else if (info2 == "tbf") {                
         k = info.find("/");
         type = type + info.left(k);
      } else if (info2 == "ingress") {
         type = type + " ffff:";         
      } else { // pfifo, bfifo
         type = type + info;
      }
                                 
   } else if (type == "class") {      
      info.remove(0,4); // remove cbq
      k = info.find(" "); info2 = " " + info.left(k+1); info.remove(0,k+8);
      type = type + info2; k = info.find(" "); info.remove(0,k); // remove parent
      k = info.find("leaf");
      if (k > 0) {
         k = info.find(" ", 6); info.remove(0,k+1); // remove leaf  
      } else info.remove(0,1);
      k = info.find(" ", 6); info2 = info.left(k); info.remove(0,k+1); // include rate
      k = info.find(" ", 6); info.remove(0,k+1); // remove cell
      k = info.find(" allot ");
      type = type + info2 + " " + info.left(k);
   } else if (type == "filter") {
      
      k = info.find("pref "); info.remove(0,k);
            
      k = info.find(" fw ");
      if (k > 0) { type = type + " " + info; }
      
      k = info.find(" route ");
      if (k > 0) {
        k = info.find(" fh ");  type = type + " " + info.left(k); info.remove(0,k+5);
        k = info.find(" "); info.remove(0,k);
        type = type + info;
      }

      k = info.find(" u32 ");
      if (k > 0) {
        k = info.find("u32 ");
        type = type + " " + info.left(k+4);
        k = info.find(" flowid"); info.remove(0,k); type = type + info;
      }
      
      k = info.find(" tcindex ");
      if (k > 0) {
        type = type + " " + info;
      }

   }    
   return type;
} 

void FolderListItem::insertSubFolders( const QObjectList *lst )
{
    Folder *f;
    for ( f = ( Folder* )( ( QObjectList* )lst )->first(); f; f = ( Folder* )( ( QObjectList* )lst )->next() )
	(void)new FolderListItem( this, f );
}

ListViews::ListViews( QWidget *parent, const char *name, Ktctool *ktctool2) : QSplitter( Qt::Horizontal, parent, name )
{
    lstFolders.setAutoDelete( TRUE );
    ktctoolview = ktctool2;
    listinfo2 = ktctoolview->listinfo;
    subqdiscs2 = ktctoolview->subqdiscs;
    devices = ktctoolview->devices;
    
// device.sprintf(ktctoolview->shaperinterfaceChoice);
// QMessageBox::critical(0,"Warning", text);
    KApplication::connect(&ffilter,SIGNAL(receivedStdout(KProcess *, char *, int)),
      this,SLOT(findfilter2(KProcess *, char*, int)));
                     
    folders = new QListView( this );
    folders->header()->setClickEnabled( FALSE );
    folders->addColumn( "QoS Tree                     " );

    uint tcdev = 0;
    while (tcdev < devices.count()) {
      QString dev = devices.at( tcdev );
      tcdev++;
      Folder *f = new Folder( 0, dev );
      lstFolders.append( f );
      initFolders(f);   
    }
        
    setupFolders();   

    folders->setRootIsDecorated( TRUE );
    setResizeMode( folders, QSplitter::KeepSize );

    connect( folders, SIGNAL( contextMenuRequested( QListViewItem *, const QPoint& , int ) ),
    this, SLOT( slotRMB( QListViewItem*, const QPoint &, int ) ) );

    // some preparations
    if (listinfo2.isEmpty() != TRUE) {
        QListViewItemIterator it( folders);
        for ( ; it.current(); ++it )
          it.current()->setOpen( TRUE );
        folders->firstChild()->setOpen( TRUE );
        folders->setCurrentItem( folders->firstChild()->firstChild() );
        folders->setSelected( folders->firstChild()->firstChild(), TRUE );
    }
    
}

void ListViews::initFolders(Folder *f)
{

  Ktctool::Tcobjects *objects;
  Ktctool::Tcobjects *objects2;
  QString tcobject,tcobject2;
  QString type, id, info, found, cbq, dev;

    for ( objects=listinfo2.first(); objects != 0; objects=listinfo2.next() ) {
      found = "";
      tcobject.sprintf("%s", objects->type().latin1());
      if (tcobject == "qdisc") {
        tcobject.sprintf("%s", objects->id().latin1());
      }
      if (tcobject == "ffff:") {  // ingress found
        info.sprintf("%s", objects->info().latin1());
        dev.sprintf("%s", objects->dev().latin1());
        if (f->folderName() == dev) {
          found = "ingress";
          break;
        }
      }
    }
    if (found == "ingress") {
      info = dev + " " + info;
      Folder *f2 = new Folder( f, info ); // ingress found
      findfilter(f2, &dev);  // find filters
    }
    
    cbq = "";    
    for ( objects=listinfo2.first(); objects != 0; objects=listinfo2.next() ) {         
      found = "";
      tcobject.sprintf("%s", objects->type().latin1());
      if (tcobject == "qdisc") {
        tcobject.sprintf("%s", objects->id().latin1());
        for ( objects2=subqdiscs2.first(); objects2 != 0; objects2=subqdiscs2.next() ) {  
          id.sprintf("%s", objects2->type().latin1());
          if (tcobject == id) {   // this qdisc is subqdisc
            found = "ok";
            break;
          }
        }
      }
      if (found != "ok" && tcobject != "ffff:") {  // this qdisc is root     
        info.sprintf("%s", objects->info().latin1());
        cbq.sprintf("%s", objects->id().latin1());
        dev.sprintf("%s", objects->dev().latin1());
        if (f->folderName() == dev) {
          found = "root";
          break;
        }
      }
    }   
    if (found == "root") {
      info = dev + " " + info;

      Folder *f2 = new Folder( f, info ); // root found
      findsub(&cbq, f2, &dev);  // recursively find subobjects
    }
 
}

void ListViews::findsub(QString *rootid, Folder *folder, QString *device1) {

    QPtrList<Ktctool::Tcobjects> listinfo;
    Ktctool::Tcobjects *objects;
    Ktctool::Tcobjects *objects2;
    Folder *f2;         
    QString type, id, info, id2, id3, text, skip, dev, device;
    int p;

    id2 = *rootid;
    device = *device1;
         
  if (listinfo2.isEmpty() != TRUE && id2 != "no") {

    for ( objects=listinfo2.first(); objects != 0; objects=listinfo2.next() ) {
       info.sprintf("%s", objects->info().latin1());
       dev.sprintf("%s", objects->dev().latin1());
       skip = "no";

       if (dev == device) {
       p = info.find( "lass " );
       if (p == 1) {
         p = info.find( " root " );
         if (p > 0) skip = "yes";
       }
       if (skip == "no") {      

          id3 = "parent " + id2 + " ";
          p = info.find( id3 );
          if (p > 0) {
              info = dev + " " + info;
              f2 = new Folder( folder, info );
              objects->setfolder(f2);
              listinfo.append(objects);
              listinfo2.remove();
              listinfo2.prev();
          }

          p = info.find( "disc " );  // check subqdiscs
          if (p == 1) {
            for ( objects2=subqdiscs2.first(); objects2 != 0; objects2=subqdiscs2.next() ) {
              id.sprintf("%s", objects2->id().latin1());
              if (id2 == id) {   // this qdisc is subqdisc
                id3.sprintf("%s", objects2->type().latin1());
                p = info.find( id3 );
                if (p > 0) {
                  info = dev + " " + info;
                  f2 = new Folder( folder, info );
                  objects->setfolder(f2);
                  listinfo.append(objects);
                  break;
                }
              } // end if id2 = id
            }
          }

       } // end if (skip == "no")
       } // end if device is same
    } // end for
    
      
    if (listinfo.isEmpty() != TRUE)
       for ( objects=listinfo.first(); objects != 0; objects=listinfo.next() ) {         
          f2 = objects->folder();
          id2.sprintf("%s", objects->id().latin1());
          id2.sprintf("%s", objects->id().latin1());          
          findsub(&id2, f2, &device);                   
       }
           
  }  
}

void ListViews::findfilter(Folder *, QString *device1) {

  ingressdevice = *device1;
  
  ffilter << "tc" << "filter" << "show" << "dev" << ingressdevice << "parent" << "ffff:";
  ffilter.start(KProcess::NotifyOnExit, KProcess::AllOutput);

}

void ListViews::findfilter2(KProcess *, char *data, int len) {

  if (len<0)
    return;
  static QString remainder;
  QString list;
  QStrList lines;

  char dst[25000];
  memmove(dst,data,len);
  dst[len]=0;

  list=remainder+dst;

  int index=0;
  int newindex=0;

  while (1)
   {
    newindex=list.find('\n',index);
    if(newindex==-1) {
      remainder=list.right(list.length()-index);
      break;
    } else {
      lines.append(list.mid(index,newindex-index));
      index=newindex+1;
    };
  };
  QString data2, info2, info3, id, info;
  int k = 0;
  if(lines.count()>0) {
    QListViewItemIterator it( folders);
    for ( ; it.current(); ++it ) {
      info = it.current()->text(1);
      k = info.find("ingress");
      if (k > 0) { k = info.find(ingressdevice);
      if (k >= 0) break;
      }
    }
    FolderListItem *Item = (FolderListItem *) it.current(); // this is ingress device 
    for (uint i = 0; i < lines.count(); ++i ) {
      data2 = lines.at( i );
      if (data2.startsWith("f")) {
         info3 = data2;
         k = data2.find(" "); data2.remove(0,k+1); // data2 to the same form as usual filters
         data2 = "eth0 filter parent ffff: " + data2;
         k = info3.find("pref ");
         info3.remove(0,k+5);
         if (info3.length() < 9) { } //fw, u32, route - skip first line
         else {                                  
             Folder *f2 = new Folder( 0, data2 ); // new ingress filter
             (void)new FolderListItem( Item, f2 );                        
         }
       }
    }
  }
  
}
        
void ListViews::setupFolders()
{
    folders->clear();

    for ( Folder* f = lstFolders.first(); f; f = lstFolders.next() ) 
      (void)new FolderListItem( folders, f );
}


// popup menu
void ListViews::slotRMB( QListViewItem* Item, const QPoint & point, int )
{
    int f, p;
    
    if( Item ) {
      info = Item->text(0);
      menu = new QPopupMenu( folders );
      
      if (info.length() < 7) {  // network interface
          QPopupMenu *menu2 = new QPopupMenu( folders );
          menu2->insertItem( QString( "Add CBQ" ), this, SLOT(slotAddQdisccbq()) );
          menu2->insertItem( QString( "Add DSMARK" ), this, SLOT(slotAddQdiscdsmark()) );
          menu2->insertItem( QString( "Add PFIFO" ), this, SLOT(slotAddQdiscpfifo()) );
          menu2->insertItem( QString( "Add PRIO" ), this, SLOT(slotAddQdiscprio()) );
          menu2->insertItem( QString( "Add RED" ), this, SLOT(slotAddQdiscred()) );
          menu2->insertItem( QString( "Add SFQ" ), this, SLOT(slotAddQdiscsfq()) );          
          menu2->insertItem( QString( "Add TBF" ), this, SLOT(slotAddQdisctbf()) );
          menu2->insertItem( QString( "Add Ingress" ), this, SLOT(slotAddQdiscingress()) );
          if (Item->childCount() < 1)
            menu->insertItem( QString( "Add qdisc" ), menu2 );
          //menu->insertItem( QString( "Add filter" ), this, SLOT(slotAddFilter()) );         
      } else {
         info = Item->text(1);
                 
         f = info.find( "ingress");
         if (f < 1) {
         f = info.find( "filter");
         if (f < 1) {
           p = info.find( "class " );
           if (p > 0) {
             QPopupMenu *menu2 = new QPopupMenu( folders );
             menu2->insertItem( QString( "Add CBQ" ), this, SLOT(slotAddQdisccbq()) );
             menu2->insertItem( QString( "Add PFIFO" ), this, SLOT(slotAddQdiscpfifo()) );
             menu2->insertItem( QString( "Add RED" ), this, SLOT(slotAddQdiscred()) );
             menu2->insertItem( QString( "Add SFQ" ), this, SLOT(slotAddQdiscsfq()) );
             menu2->insertItem( QString( "Add TBF" ), this, SLOT(slotAddQdisctbf()) );
             if (Item->childCount() < 1)
               menu->insertItem( QString( "Add qdisc" ), menu2 );
           }
           
           p = info.find( "qdisc cbq " );  // can't change cbq, dsmark, sfq qdiscs
           if (p < 1)  p = info.find( "qdisc dsmark " );
           if (p < 1)  p = info.find( "qdisc sfq " );

           if (p > 0)
             menu->insertItem( QString( "Copy info" ), this, SLOT(slotChange()) );
           else
             menu->insertItem( QString( "Change" ), this, SLOT(slotChange()) );
             
           p = info.find( "qdisc cbq " );
           if (p > 0)
             menu->insertItem( QString( "Add class" ), this, SLOT(slotAddClass()) );
             //menu->insertItem( QString( "Add filter" ), this, SLOT(slotAddFilter()) );
           p = info.find( "class cbq " );
           if (p > 0)
             menu->insertItem( QString( "Add class" ), this, SLOT(slotAddClass()) );  
         }
         }
         menu->insertItem( QString( "Delete" ), this, SLOT(slotDelete()) );         
      }
      menu->popup( point );
    }
}


void ListViews::slotAddQdisccbq()
{
  info = info + " " + "cbq";
  ktctoolview->addQdisc(info);
}
void ListViews::slotAddQdiscdsmark()
{
  info = info + " " + "dsmark";
  ktctoolview->addQdisc(info);
}
void ListViews::slotAddQdiscpfifo()
{
  info = info + " " + "pfifo";
  ktctoolview->addQdisc(info);
}  
void ListViews::slotAddQdiscprio()
{
  info = info + " " + "prio";
  ktctoolview->addQdisc(info);
}
void ListViews::slotAddQdiscred()
{
  info = info + " " + "red";
  ktctoolview->addQdisc(info);
}
void ListViews::slotAddQdiscsfq()
{
  info = info + " " + "sfq";
  ktctoolview->addQdisc(info);
}   
void ListViews::slotAddQdisctbf()
{
  info = info + " " + "tbf";
  ktctoolview->addQdisc(info);  
}
void ListViews::slotAddQdiscingress()
{
  info = info + " " + "ingress";
  ktctoolview->addQdisc(info);
}          

void ListViews::slotAddFilter()
{

   ktctoolview->addFilter(info);

}


void ListViews::slotAddClass()
{

   ktctoolview->addClass(info);

}


void ListViews::slotChange()
{
      
     ktctoolview->setInfo(info);
     
}


void ListViews::slotDelete()
{
    QString type, id, device;

    int k = info.find(" ");   // object info -> like shaperdelinterfaceChoice
    device = info.left(k); info.remove(0,k+1);
    k = info.find(" ");   
    type = info.left(k); info.remove(0,k+1);
    k = info.find(" "); info.remove(0,k+1);
    k = info.find(" ");
    id = info.left(k);   
    if (type == "filter") {
      k = info.find("pref "); info.remove(0,k+5);
      k = info.find(" ");
      id = id + " prio " + info.left(k);
    }
    id.sprintf("dev %s %s %s",device.latin1(),type.latin1(),id.latin1());
    ktctoolview->shaperdelinterfaceChoice = id;    
    ktctoolview->delshaperRules();

}
