/***************************************************************************
                          ktctool_shaper.cpp  -  description
                             -------------------
    begin                : Fri Feb 1 2002
    copyright            : (C) 2002 by Vairo Raja
    email                : ktctool@fr.ee
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ktctool.h"


// execute tc command line
void Ktctool::startshaperRules() {
    QString shaperglobalband, shaperrateband, shaperqdischandle, shaperqdiscparent, shaperparenthandle, shaperclassid, shaperclassweight, shaperclassprio, shaperinterface;
    QString shaperavpkt, shapermpu, shapercell, shaperewma, shaperclassmaxburst, shaperclassminburst, shaperclassallot, shaperclasssplit, shaperclassdefmap, start;
    QRegExp isinteger = QRegExp("^[0-9][.0-9]*[mMKkbB]*[itIT]*$");
    QRegExp isbps = QRegExp("^[0-9][.0-9]*[mMKkbB]*[itpsITPS]*$");
    bool successqdisc = false;
    bool successrootclass = false;

    shaperinterface.sprintf(shaperinterfaceChoice);
	
    shaperglobalband.sprintf((const char *)(shaperglobalBand->text()));
    shaperrateband.sprintf((const char *)(shaperrateBand->text()));
    shaperqdischandle.sprintf((const char *)(shaperqdiscHandle->text()));
    shaperqdiscparent.sprintf((const char *)(shaperqdiscParent->text()));
    shaperavpkt.sprintf((const char *)(shaperAvpkt->text()));
    shapermpu.sprintf((const char *)(shaperMpu->text()));
    shapercell.sprintf((const char *)(shaperCell->text()));
    shaperewma.sprintf((const char *)(shaperEwma->text()));

    shaperclassid.sprintf((const char *)(shaperclassId->text()));
    shaperparenthandle.sprintf((const char *)(shaperparentHandle->text()));
    shaperclassweight.sprintf((const char *)(shaperclassWeight->text()));
    shaperclassprio.sprintf((const char *)(shaperclassPrio->text()));
    shaperclassmaxburst.sprintf((const char *)(shaperclassMaxburst->text()));
    shaperclassminburst.sprintf((const char *)(shaperclassMinburst->text()));
    shaperclassallot.sprintf((const char *)(shaperclassAllot->text()));
    shaperclasssplit.sprintf((const char *)(shaperclassSplit->text()));
    shaperclassdefmap.sprintf((const char *)(shaperclassDefmap->text()));
        
    addshaperqdisc.clearArguments();
    addshaperclass.clearArguments();
    start = "yes";

    if(shaperglobalband.contains(isbps)) { }
    else {
	    QMessageBox::critical(0, "Error",
			       i18n("You have to supply global bandwidht on net interface \n e.g. 100Mbit! \n"));
      start = "no";
    }


 if ( qdisc_exec == 1 )
      {
	if ((shaperqdischandle.length()==0)||(shaperqdischandle.contains(" ")))
	  {
	    QMessageBox::critical(0, "Error",
				   i18n("You have to supply the qdisc handle! \n e.g. 1! \n"));
	  }
	else
	  {
      if (tcexistid == "no") start = "no";
	    addshaperqdisc << "tc" << "qdisc" << "add" << "dev" << shaperinterface;
      if ((shaperqdiscparent.length()==0)||(shaperqdiscparent.contains(" "))) addshaperqdisc << "root";
      else addshaperqdisc << "parent" << shaperqdiscparent;
      addshaperqdisc << "handle" << shaperqdischandle <<  "cbq" << "bandwidth" << shaperglobalband << "avpkt" ;

      if (shaperavpkt.contains(isinteger)) addshaperqdisc << shaperavpkt;
      else addshaperqdisc << "1000";
      if (shapermpu.contains(isinteger)) addshaperqdisc << "mpu" << shapermpu;
      if (shapercell.contains(isinteger)) addshaperqdisc << "cell" << shapercell;
      if (shaperewma.contains(isinteger)) addshaperqdisc << "ewma" << shaperewma;
	  }
  if (start == "yes")
	  successqdisc=addshaperqdisc.start();
	if (successqdisc) {
	  statusbar->message(i18n("New qdisc created"), 2000);
	  QString msg;
	  msg.sprintf( i18n("qdisc created for interface %s"), shaperinterfaceChoice);
	  messageLog->insertItem(msg);
    addLog(addshaperqdisc);
    tcdev = 0;
    listinfo.clear();
    subqdiscs.clear();
    startMonitorProcess(); // refresh window
	} else {
	  statusbar->message(i18n("tc died"), 2000);
	  QMessageBox::critical(0, "Error",
				 i18n("qdisc has not been created, please check your parameters! \n"));
	}
      }


 if ( class_exec == 1 )
      {

	if ((shaperparenthandle.length()==0)||(shaperparenthandle.contains(" ")))
	  {
	    QMessageBox::critical(0, "Error",
				   i18n("You have to supply the class parent handle! \n e.g. 1:0! \n"));
	  }
	else if ((shaperclassid.length()==0)||(shaperclassid.contains(" ")))
	  {
	    QMessageBox::critical(0, "Error",
				   i18n("You have to supply the class ID! \n e.g. 1:10! \n"));
	  }
	else if (shaperrateband.contains(isbps) <= 0)
	  {
	    QMessageBox::critical(0, "Error",
				   i18n("You have to supply the class rate! \n e.g. 8Mbit! \n"));
	  }
	else
	  {
       
      if (tcexistid == "no") start = "no";
	    addshaperclass << "tc" << "class";
      if (startfunction == "change") addshaperclass << "change";
      else addshaperclass << "add";
      addshaperclass << "dev" << shaperinterface << "parent" << shaperparenthandle << "classid" << shaperclassid << "cbq" << "bandwidth" << shaperglobalband << "rate" << shaperrateband;
      if (shaperclassmaxburst.contains(isinteger)) addshaperclass << "maxburst" << shaperclassmaxburst;
      if (shaperavpkt.contains(isinteger)) addshaperclass << "avpkt" << shaperavpkt;
      else addshaperclass << "avpkt" << "1000";
      if (shapermpu.contains(isinteger)) addshaperclass << "mpu" << shapermpu;
      if (shapercell.contains(isinteger)) addshaperclass << "cell" << shapercell;
      if (shaperewma.contains(isinteger)) addshaperclass << "ewma" << shaperewma;
      if (shaperclassallot.contains(isinteger)) addshaperclass << "allot" << shaperclassallot;
      if (shaperclassweight.contains(isbps)) addshaperclass << "weight" << shaperclassweight;
      if (shaperclassprio.contains(isinteger)) addshaperclass << "prio" << shaperclassprio;
      if (shaperclassminburst.contains(isinteger)) addshaperclass << "minburst" << shaperclassminburst;
      if (bounded == 1) addshaperclass << "bounded";
      if (isolated == 1) addshaperclass << "isolated";
      if ((shaperclasssplit.length()==0)||(shaperclasssplit.contains(" "))) {}
      else if ((shaperclassdefmap.length()==0)||(shaperclassdefmap.contains(" "))) {}
      else addshaperclass << "split" << shaperclasssplit << "defmap" << shaperclassdefmap;
     
  if (start == "yes")
		  successrootclass=addshaperclass.start();

		if (successrootclass) {
      QString msg;
      if (startfunction == "change") {
      statusbar->message(i18n("Class changed"), 2000);
		  msg.sprintf( i18n("class changed for interface %s"), shaperinterfaceChoice);
      } else {
		  statusbar->message(i18n("New class created"), 2000);
		  msg.sprintf( i18n("class created for interface %s"), shaperinterfaceChoice);
      }
		  messageLog->insertItem(msg);
      addLog(addshaperclass);
      tcdev = 0;
      listinfo.clear();
      subqdiscs.clear();
      startMonitorProcess(); // refresh window 
		} else {
		  statusbar->message(i18n("tc died"), 2000);
		  QMessageBox::critical(0, "Error",
					 i18n("class has not been created, please check your parameters! \n"));
		}
	  }
    class_exec = 0;

      }

};


// create CBQ rules
void Ktctool::trafficShaper() {

  QBoxLayout *top = new QBoxLayout(tab_1, QBoxLayout::LeftToRight, 10);
	QGridLayout * grid = new QGridLayout(10,11);
	top->addLayout(grid);

	QLabel *labelshaperInterface = new QLabel(tab_1);
	labelshaperInterface->setText(i18n("Interface:"));
	grid->addMultiCellWidget(labelshaperInterface,0,0,0,0,AlignRight);

	shaperinterface = new QComboBox( FALSE, tab_1, "interface");
	shaperinterface->insertStrList(devices);
	shaperinterface->setFixedHeight(shaperinterface->sizeHint().height());
	connect(shaperinterface,SIGNAL(activated(int)), SLOT(shaperinterfaceActivated(int)));
	grid->addMultiCellWidget(shaperinterface,0,0,1,1);

	QLabel *labelqdischandle = new QLabel(tab_1);
	labelqdischandle->setText(i18n("qdisc handle:"));

	shaperqdiscHandle = new QLineEdit(tab_1);
	shaperqdiscHandle->setFixedHeight(shaperqdiscHandle->sizeHint().height());
	shaperqdiscHandle->setText("1:");

	grid->addMultiCellWidget(labelqdischandle,1,1,0,0,AlignRight);
	grid->addMultiCellWidget(shaperqdiscHandle,1,1,1,1);

	QLabel *labelshaperglobalBand = new QLabel(tab_1);
	labelshaperglobalBand->setText(i18n("net bandwidth:"));
	shaperglobalBand = new QLineEdit(tab_1);
	shaperglobalBand->setFixedHeight(shaperglobalBand->sizeHint().height());
	shaperglobalBand->setText("100Mbit");

	grid->addMultiCellWidget(labelshaperglobalBand,0,0,2,2,AlignRight);
	grid->addMultiCellWidget(shaperglobalBand,0,0,3,3);

 	QLabel *labelshaperAvpkt = new QLabel(tab_1);
	labelshaperAvpkt->setText("avpkt:");
 	shaperAvpkt = new QLineEdit(tab_1);
	shaperAvpkt->setFixedHeight(shaperAvpkt->sizeHint().height());
	shaperAvpkt->setText("1000");

 	QLabel *labelshaperMpu = new QLabel(tab_1);
	labelshaperMpu->setText("mpu:");
 	shaperMpu = new QLineEdit(tab_1);
	shaperMpu->setFixedHeight(shaperMpu->sizeHint().height());
	shaperMpu->setText("");

	grid->addMultiCellWidget(labelshaperAvpkt,0,0,4,4,AlignRight);
	grid->addMultiCellWidget(labelshaperMpu,1,1,4,4,AlignRight);
	grid->addMultiCellWidget(shaperAvpkt,0,0,5,5);
	grid->addMultiCellWidget(shaperMpu,1,1,5,5);

 	QLabel *labelshaperCell = new QLabel(tab_1);
	labelshaperCell->setText("cell:");
  shaperCell = new QLineEdit(tab_1);
	shaperCell->setFixedHeight(shaperCell->sizeHint().height());
	shaperCell->setText("8");

 	QLabel *labelshaperEwma = new QLabel(tab_1);
	labelshaperEwma->setText("ewma:");
  shaperEwma = new QLineEdit(tab_1);
	shaperEwma->setFixedHeight(shaperEwma->sizeHint().height());
	shaperEwma->setText("");

	grid->addMultiCellWidget(labelshaperCell,0,0,6,6,AlignRight);
	grid->addMultiCellWidget(labelshaperEwma,1,1,6,6,AlignRight);
	grid->addMultiCellWidget(shaperCell,0,0,7,7);
	grid->addMultiCellWidget(shaperEwma,1,1,7,7);

	QLabel *labelqdiscparent = new QLabel(tab_1);
	labelqdiscparent->setText(i18n("qdisc parent:"));

	shaperqdiscParent = new QLineEdit(tab_1);
	shaperqdiscParent->setFixedHeight(shaperqdiscParent->sizeHint().height());
	shaperqdiscParent->setText("");

	grid->addMultiCellWidget(labelqdiscparent,2,2,0,0,AlignRight);
	grid->addMultiCellWidget(shaperqdiscParent,2,2,1,1);

	QPushButton *btnShaper = new QPushButton(tab_1);
	btnShaper->setText( i18n("Add qdisc"));
	btnShaper->setFixedHeight(btnShaper->sizeHint().height());
	connect(btnShaper,SIGNAL(clicked()), this, SLOT(shaperQdisc()));
	grid->addWidget(btnShaper,2,2);

	QLabel *labelqdiscend = new QLabel(tab_1);
	labelqdiscend->setText("");
	grid->addMultiCellWidget(labelqdiscend,3,3,0,0,AlignRight);
// qdisc end
// class
	QLabel *labelparentid = new QLabel(tab_1);
	labelparentid->setText(i18n("class parent:"));

	shaperparentHandle = new QLineEdit(tab_1);
	shaperparentHandle->setFixedHeight(shaperparentHandle->sizeHint().height());
	shaperparentHandle->setText("1:");

	grid->addMultiCellWidget(labelparentid,4,4,0,0,AlignRight);
	grid->addMultiCellWidget(shaperparentHandle,4,4,1,1);

	QLabel *labelclassid = new QLabel(tab_1);
	labelclassid->setText(i18n("class id:"));

	shaperclassId = new QLineEdit(tab_1);
	shaperclassId->setFixedHeight(shaperclassId->sizeHint().height());
	shaperclassId->setText("1:10");

	grid->addMultiCellWidget(labelclassid,5,5,0,0,AlignRight);
	grid->addMultiCellWidget(shaperclassId,5,5,1,1);

	QLabel *labelshaperrateBand = new QLabel(tab_1);
	labelshaperrateBand->setText("reserved rate:");
	shaperrateBand = new QLineEdit(tab_1);
	shaperrateBand->setFixedHeight(shaperrateBand->sizeHint().height());
	shaperrateBand->setText("8Mbit");

	grid->addMultiCellWidget(labelshaperrateBand,4,4,2,2,AlignRight);
	grid->addMultiCellWidget(shaperrateBand,4,4,3,3);

	QLabel *labelclassweight = new QLabel(tab_1);
	labelclassweight->setText("weight:");

	shaperclassWeight = new QLineEdit(tab_1);
	shaperclassWeight->setFixedHeight(shaperclassWeight->sizeHint().height());
	shaperclassWeight->setText("0.8Mbit");

	grid->addMultiCellWidget(labelclassweight,5,5,2,2,AlignRight);
	grid->addMultiCellWidget(shaperclassWeight,5,5,3,3);

	QLabel *labelclassallot = new QLabel(tab_1);
	labelclassallot->setText("allot:");

	shaperclassAllot = new QLineEdit(tab_1);
	shaperclassAllot->setFixedHeight(shaperclassAllot->sizeHint().height());
	shaperclassAllot->setText("1514");

	grid->addMultiCellWidget(labelclassallot,4,4,4,4,AlignRight);
	grid->addMultiCellWidget(shaperclassAllot,4,4,5,5);

	QLabel *labelclassprio = new QLabel(tab_1);
	labelclassprio->setText("priority:");

	shaperclassPrio = new QLineEdit(tab_1);
	shaperclassPrio->setFixedHeight(shaperclassPrio->sizeHint().height());
	shaperclassPrio->setText("6");

	grid->addMultiCellWidget(labelclassprio,5,5,4,4,AlignRight);
	grid->addMultiCellWidget(shaperclassPrio,5,5,5,5);

	QLabel *labelclassmaxb = new QLabel(tab_1);
	labelclassmaxb->setText("maxburst:");

	shaperclassMaxburst = new QLineEdit(tab_1);
	shaperclassMaxburst->setFixedHeight(shaperclassMaxburst->sizeHint().height());
	shaperclassMaxburst->setText("20");
  
	grid->addMultiCellWidget(labelclassmaxb,4,4,6,6,AlignRight);
	grid->addMultiCellWidget(shaperclassMaxburst,4,4,7,7);

	QLabel *labelclassminb = new QLabel(tab_1);
	labelclassminb->setText("minburst:");

	shaperclassMinburst = new QLineEdit(tab_1);
	shaperclassMinburst->setFixedHeight(shaperclassMinburst->sizeHint().height());
	shaperclassMinburst->setText("");

	grid->addMultiCellWidget(labelclassminb,5,5,6,6,AlignRight);
	grid->addMultiCellWidget(shaperclassMinburst,5,5,7,7);

  shaperclassBounded = new QCheckBox("bounded", tab_1);
  shaperclassBounded->setAutoRepeat( FALSE );
  shaperclassBounded->setAutoResize( FALSE );
  connect(shaperclassBounded,SIGNAL(clicked()), this, SLOT(setBounded()));
  grid->addWidget(shaperclassBounded,6,2);

  shaperclassIsolated = new QCheckBox("isolated", tab_1);
  shaperclassIsolated->setAutoRepeat( FALSE );
  shaperclassIsolated->setAutoResize( FALSE );
  connect(shaperclassIsolated,SIGNAL(clicked()), this, SLOT(setIsolated()));
  grid->addWidget(shaperclassIsolated,6,3);

  QLabel *labelclasssplit = new QLabel(tab_1);
	labelclasssplit->setText("split:");

	shaperclassSplit = new QLineEdit(tab_1);
	shaperclassSplit->setFixedHeight(shaperclassSplit->sizeHint().height());
	shaperclassSplit->setText("");

	grid->addMultiCellWidget(labelclasssplit,6,6,4,4,AlignRight);
	grid->addMultiCellWidget(shaperclassSplit,6,6,5,5);

  QLabel *labelclassdefmap = new QLabel(tab_1);
	labelclassdefmap->setText("defmap:");

	shaperclassDefmap = new QLineEdit(tab_1);
	shaperclassDefmap->setFixedHeight(shaperclassDefmap->sizeHint().height());
	shaperclassDefmap->setText("");

	grid->addMultiCellWidget(labelclassdefmap,6,6,6,6,AlignRight);
	grid->addMultiCellWidget(shaperclassDefmap,6,6,7,7);
    
	QPushButton *btnClass = new QPushButton(tab_1);
	btnClass->setText( i18n("Add class"));
	btnClass->setFixedHeight(btnClass->sizeHint().height());
	connect(btnClass,SIGNAL(clicked()), this, SLOT(shaperClass()));
  grid->addWidget(btnClass,7,2);
  
  QPushButton *btnChange = new QPushButton(tab_1);
  btnChange->setText( i18n("Change class"));
  btnChange->setFixedHeight(btnChange->sizeHint().height());
  connect(btnChange,SIGNAL(clicked()), this, SLOT(startClassChange()));
  grid->addWidget(btnChange,7,3);
  
	QLabel *labelclassend = new QLabel(tab_1);
	labelclassend->setText("");
	grid->addMultiCellWidget(labelclassend,8,8,0,0,AlignRight);
  QLabel *labelclassend2 = new QLabel(tab_1);
	labelclassend2->setText("");
	grid->addMultiCellWidget(labelclassend2,9,9,0,0,AlignRight);
  

  QWhatsThis::add (shaperinterface, i18n("Select network interface."));
  QWhatsThis::add (shaperglobalBand, i18n("The physical bandwidth of your interface, needed for idle time calculations. Most often 10Mbit or 100Mbit. (bps/8 = bit)"));
  QWhatsThis::add (shaperAvpkt, i18n("Average size of a packet, measured in bytes. Needed for calculating maxidle,which is derived from maxburst, which is specified in packets. Default is 1000. Usually don't change."));
  QWhatsThis::add (shaperMpu, i18n("Not required. Default is 64. Mininum packet size - needed because even a zero size packet is padded to 64 bytes on ethernet, and so takes a certain time to transmit. \
CBQ needs to know this to accurately calculate the idle time."));
  QWhatsThis::add (shaperCell, i18n("Not required, but recommended. The time a packet takes to be transmitted over a interface may grow in steps, based on the packet size. An 800 and an 806 size packet may take just as long to send, \
for example - this sets the granularity. Most often set to '8'. Must be an integral power of two."));
  QWhatsThis::add (shaperEwma, i18n("Not required. An integer (log). Ewma='exponential weighted moving average', considers recent packets to be exponentially more important than past ones."));
	QWhatsThis::add (shaperqdiscHandle, i18n("This is the handle (major:minor) you want to give it. The minor number must be zero."));
	QWhatsThis::add (shaperqdiscParent, i18n("Only required if not root. Parent CLASS ID, e. g. 1:10 (which is specifying the parent of this qdisc)."));
  QWhatsThis::add (btnShaper, i18n("Add qdisc. Root if qdisc parent field is empty."));

  QWhatsThis::add (shaperrateBand, i18n("Class bandwidth. If bounded is set - this is the maximum rate of traffic leaving this class (and subclasses)."));
	QWhatsThis::add (shaperparentHandle, i18n("Parent class id."));
 	QWhatsThis::add (shaperclassId, i18n("Class ID (parent:current class)."));
	QWhatsThis::add (shaperclassWeight, i18n("Not required, but recommended. Each class gets a chance to send in turn. If you have classes with significantly more bandwidth than other classes, it makes sense to allow them to send more data in one round than the others. \
\n A CBQ adds up all weights under a class, and normalizes them. People have been using 'reserved rate/10' as a rule of thumb. The renormalized weight is multiplied by the 'allot' parameter to determine how much data can be sent in one round."));
  QWhatsThis::add (shaperclassPrio, i18n("Not required, but recommended. The CBQ can also act like the PRIO device. Inner classes with lower priority are tried first and as long as they have traffic, other classes are not polled for traffic."));
  QWhatsThis::add (shaperclassAllot, i18n("Not required, but recommended. Each time a class gets its turn, it can only send out a limited amount of data. 'Allot' is the base unit of this amount."));
  QWhatsThis::add (shaperclassMaxburst, i18n("This number of packets is used to calculate \
maxidle so that when avgidle is at maxidle, this number of average packets can be burst before avgidle drops to 0. Set it higher to be more tolerant of bursts. You can't set maxidle directly, only via this parameter."));
  QWhatsThis::add (shaperclassMinburst, i18n("Not required. CBQ needs to throttle in case of overlimit. The ideal solution is to do so for exactly the calculated idle time, and pass 1 packet. Kernels generally have a hard time scheduling \
events shorter than 10ms, so it is better to throttle for a longer period, and then pass minburst packets in one go, and then sleep minburst times longer."));
 	QWhatsThis::add (shaperclassBounded, i18n("Bounded means that it will not try to borrow bandwidth from sibling classes. Within such an agency class, there might be other classes which are allowed to swap bandwidth."));
 	QWhatsThis::add (shaperclassIsolated, i18n("A class that is configured with 'isolated' will not lend out bandwidth to sibling classes. Use this if you have competing or mutually-unfriendly agencies on your link who do want to give each other freebies."));
 	QWhatsThis::add (shaperclassSplit, i18n("Not required. Use split & defmap if you want to filter on the Type of Service field only. Classid (e. g. 1:10), which is where the choice will be made. The packets' priority bits are or-ed with the defmap field to see if a match exists. \
In other words, this is a short-hand way of creating a fast filter, which only matches certain priorities."));
 	QWhatsThis::add (shaperclassDefmap, i18n("A defmap of ff (hex) will match everything, a defmap of 0 nothing. C0 is binary for 11000000, 3F for 00111111, so these two together will match everything. The first class matches bits 7 & 6, and thus \
corresponds to 'interactive' and 'control' traffic. Check PRIO info."));
  QWhatsThis::add (btnClass, i18n("Add class or subclass."));
  QWhatsThis::add (btnChange, i18n("Change class parameters. The class must exist."));

  tab_1->show();

};


// menu widget choice device
void Ktctool::shaperinterfaceActivated(int index) {

  switch(index) {
  default:
    shaperinterfaceChoice = devices.at(0);
  case 0:
    shaperinterfaceChoice = devices.at(0);
    break;
  case 1:
    shaperinterfaceChoice = devices.at(1);
    break;
  case 2:
    shaperinterfaceChoice = devices.at(2);
    break;
  case 3:
    shaperinterfaceChoice = devices.at(3);
    break;
  case 4:
    shaperinterfaceChoice = devices.at(4);
    break;
  case 5:
    shaperinterfaceChoice = devices.at(5);
    break;
  case 6:
    shaperinterfaceChoice = devices.at(6);
    break;
  case 7:
    shaperinterfaceChoice = devices.at(7);
    break;
  case 8:
    shaperinterfaceChoice = devices.at(8);
    break;
  };

};

// modify qdisc
void Ktctool::shaperQdisc() {
      QString shaperinterface, tcid;

      class_exec=0;
      qdisc_exec=1;
      startfunction = "startshaperRules";

      shaperinterface.sprintf(shaperinterfaceChoice);
      tcid.sprintf((const char *)(shaperqdiscHandle->text()));
      QString tctype = "qdisc";
      startexistShaper(shaperinterface, tcid, tctype);

};


// modify class
void Ktctool::shaperClass() {
      QString shaperinterface, tcid;

      class_exec=1;
      qdisc_exec=0;
      startfunction = "startshaperRules";

      shaperinterface.sprintf(shaperinterfaceChoice);
      tcid.sprintf((const char *)(shaperclassId->text()));
      QString tctype = "class";
      startexistShaper(shaperinterface, tcid, tctype);

};


// bounded checkbox
void Ktctool::setBounded() {

  if (bounded==0)
    {
      bounded=1;
    }
  else
    {
      bounded=0;
    }

};


// isolated checkbox
void Ktctool::setIsolated() {

  if (isolated==0)
    {
      isolated=1;
    }
  else
    {
      isolated=0;
    }

};


// start changing parameters
void Ktctool::startClassChange() {
  
  class_exec=1;
  qdisc_exec=0;
  startfunction = "change";
  startshaperRules();

};


// Traffic Control's Rules Monitor
// 1. qdisc Monitor
void Ktctool::startqdiscMonitor() {

  showip.clearArguments();
  showqdisc.clearArguments();

  showip << "ip" << "addr" << "show" << "dev" << shapermonitorinterfaceChoice;
  showqdisc << "tc";
  if (tcs_exec == 1) showqdisc << "-s";
  if (tcd_exec == 1) showqdisc << "-d";
  if (tcr_exec == 1) showqdisc << "-r";
  showqdisc << "qdisc" << "show" << "dev" << shapermonitorinterfaceChoice;

  bool showaddr=showip.start(KProcess::NotifyOnExit, KProcess::AllOutput);
  if (showaddr) {
    bool success=showqdisc.start(KProcess::NotifyOnExit, KProcess::AllOutput);
    if (success)
      statusbar->message(i18n("Running..."), 2000);
    else
      statusbar->message(i18n("Couldn't start tc"), 2000);
  }
};


// 2. class Monitor
void Ktctool::startclassMonitor() {

  showip.clearArguments();
  showclass.clearArguments();

  showip << "ip" << "addr" << "show" << "dev" << shapermonitorinterfaceChoice ;
  showclass << "tc";
  if (tcs_exec == 1) showclass << "-s";
  if (tcd_exec == 1) showclass << "-d";
  if (tcr_exec == 1) showclass << "-r";
  showclass << "class" << "show" << "dev" << shapermonitorinterfaceChoice ;

  bool showaddr=showip.start(KProcess::NotifyOnExit, KProcess::AllOutput);
  if (showaddr) {
    bool success=showclass.start(KProcess::NotifyOnExit, KProcess::AllOutput);
    if (success)
      statusbar->message(i18n("Running..."), 2000);
    else
      statusbar->message(i18n("Couldn't start tc"), 2000);
  }
};


// 3. filter Monitor
void Ktctool::startfilterMonitor() {

  showip.clearArguments();
  showfilter.clearArguments();

  showip << "ip" << "addr" << "show" << "dev" << shapermonitorinterfaceChoice ;
  showfilter << "tc";
  if (tcs_exec == 1) showfilter << "-s";
  if (tcd_exec == 1) showfilter << "-d";
  if (tcr_exec == 1) showfilter << "-r";
  showfilter << "filter" << "show" << "dev" << shapermonitorinterfaceChoice ;

  bool showaddr=showip.start(KProcess::NotifyOnExit, KProcess::AllOutput);

  if (showaddr) {
    bool success=showfilter.start(KProcess::NotifyOnExit, KProcess::AllOutput);
    if (success)
      statusbar->message(i18n("Running..."), 2000);
    else
      statusbar->message(i18n("Couldn't start tc"), 2000);
  }
};


// trafficShaperMonitor - list info
void Ktctool::trafficShaperMonitor() {

      QBoxLayout *top = new QBoxLayout(tab, QBoxLayout::LeftToRight, 10);
      QGridLayout *grid = new QGridLayout(6,5);
      top->addLayout(grid);
      
      shapermonBox = new QListBox(tab);
      grid->addMultiCellWidget(shapermonBox,0,4,0,5);
      shapermonBox->insertItem(i18n("Help: press F2 or Shift+F1 and choose object."));
      shapermonBox->insertItem(i18n("Create qdisc and classes (using CBQ, ...) then create filters."));
      
      QLabel *labelshapermonInterface = new QLabel(tab);
      labelshapermonInterface->setText(i18n("Interface:"));
      grid->addMultiCellWidget(labelshapermonInterface,5,5,0,0, AlignRight);

      shapermoninterface = new QComboBox( FALSE, tab, "interface");
      shapermoninterface->insertStrList(devices);
      shapermoninterface->setFixedHeight(shapermoninterface->sizeHint().height());
      connect(shapermoninterface,SIGNAL(activated(int)), SLOT(shapermonitorinterfaceActivated(int)));
      grid->addMultiCellWidget(shapermoninterface,5,5,1,1);

      QPushButton *btnQdisc = new QPushButton(tab);
      btnQdisc->setText( i18n("Qdisc"));
      btnQdisc->setFixedHeight(btnQdisc->sizeHint().height());
      connect(btnQdisc,SIGNAL(clicked()), this, SLOT(startqdiscMonitor()));
      grid->addWidget(btnQdisc,6,2);

      QPushButton *btnClass = new QPushButton(tab);
      btnClass->setText( i18n("Class"));
      btnClass->setFixedHeight(btnClass->sizeHint().height());
      connect(btnClass,SIGNAL(clicked()), this, SLOT(startclassMonitor()));
      grid->addWidget(btnClass,6,3);

      QPushButton *btnFilter = new QPushButton(tab);
      btnFilter->setText( i18n("Filter"));
      btnFilter->setFixedHeight(btnFilter->sizeHint().height());
      connect(btnFilter,SIGNAL(clicked()), this, SLOT(startfilterMonitor()));
      grid->addWidget(btnFilter,6,4);

      QCheckBox *tcs = new QCheckBox(i18n("-statistics"), tab);
	    tcs->setAutoRepeat( FALSE );
	    tcs->setAutoResize( FALSE );
      tcs->setChecked(TRUE);
      connect(tcs,SIGNAL(clicked()), this, SLOT(tcStatistics()));
      grid->addWidget(tcs,5,2);

      QCheckBox *tcd = new QCheckBox(i18n("-details"), tab);
	    tcd->setAutoRepeat( FALSE );
	    tcd->setAutoResize( FALSE );
      tcd->setChecked(TRUE);
      connect(tcd,SIGNAL(clicked()), this, SLOT(tcDetails()));
      grid->addWidget(tcd,5,3);

      QCheckBox *tcr = new QCheckBox(i18n("-raw"), tab);
	    tcr->setAutoRepeat( FALSE );
	    tcr->setAutoResize( FALSE );
      connect(tcr,SIGNAL(clicked()), this, SLOT(tcRaw()));
      grid->addWidget(tcr,5,4);

      QWhatsThis::add (shapermonBox, i18n("Shows info about interfaces and selected tc object types (qdisc, class or filter)"));
      QWhatsThis::add (shapermoninterface, i18n("Select network interface."));
      QWhatsThis::add (btnQdisc, i18n("To view all the current defined qdiscs for selected interface."));
      QWhatsThis::add (btnClass, i18n("To view all the current defined classes for selected interface."));
      QWhatsThis::add (btnFilter, i18n("To view all the current defined filters for selected interface."));
      QWhatsThis::add (tcs, i18n("Include statistics"));
      QWhatsThis::add (tcd, i18n("Include details"));
      QWhatsThis::add (tcr, i18n("Include raw info"));

      tab->show();
      
};


// shaperMonitor
void Ktctool::shaperMonitor(KProcess *, char *data, int len) {

  if (len<0)
    return;
  static QString remainder;
  QString list;

  char dst[25000];
  memmove(dst,data,len);
  dst[len]=0;

  list=remainder+dst;
  QStrList lines;
  int index=0;
  int newindex=0;

  while (1)
   {
    newindex=list.find('\n',index);
    if(newindex==-1) {
      remainder=list.right(list.length()-index);
      break;
    } else {
      lines.append(list.mid(index,newindex-index));
      index=newindex+1;
    };
  };

  if(lines.count()>0){
    shapermonBox->insertStrList(&lines);
  };

  shapermonBox->insertItem(remainder.data());
  shapermonBox->setTopItem(shapermonBox->count()-shapermonBox->numItemsVisible());

};


// menu widget choice device
void Ktctool::shapermonitorinterfaceActivated(int index) {

  switch(index) {
  default:
    shapermonitorinterfaceChoice = devices.at(0);
  case 0:
    shapermonitorinterfaceChoice = devices.at(0);
    break;
  case 1:
    shapermonitorinterfaceChoice = devices.at(1);
    break;
  case 2:
    shapermonitorinterfaceChoice = devices.at(2);
    break;
  case 3:
    shapermonitorinterfaceChoice = devices.at(3);
    break;
  case 4:
    shapermonitorinterfaceChoice = devices.at(4);
    break;
  case 5:
    shapermonitorinterfaceChoice = devices.at(5);
    break;
  case 6:
    shapermonitorinterfaceChoice = devices.at(6);
    break;
  case 7:
    shapermonitorinterfaceChoice = devices.at(7);
    break;
  case 8:
    shapermonitorinterfaceChoice = devices.at(8);
    break;
  };

};


// tcs checkbox
void Ktctool::tcStatistics() {

  if (tcs_exec==0)
    {
      tcs_exec=1;
    }
  else
    {
      tcs_exec=0;
    }

};


// tcd checkbox
void Ktctool::tcDetails() {

  if (tcd_exec==0)
    {
      tcd_exec=1;
    }
  else
    {
      tcd_exec=0;
    }

};


// tcr checkbox
void Ktctool::tcRaw() {

  if (tcr_exec==0)
    {
      tcr_exec=1;
    }
  else
    {
      tcr_exec=0;
    }

};

