/***************************************************************************
                          ktctool_window.cpp  -  description
                             -------------------
    begin                : Fri Feb 1 2002
    copyright            : (C) 2002 by Vairo Raja
    email                : ktctool@fr.ee
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtabwidget.h>

#include "ktctool.h"

// creating widgets
void Ktctool::setupKtctoolWidget() {

  mainWidget = new QWidget(this);
//  mainWidget->setMinimumSize(700,500);

  top2 = new QBoxLayout(mainWidget, QBoxLayout::LeftToRight,5);
  grid2 = new QGridLayout(10,2);
  top2->addLayout(grid2);
  
  treeWidget = new QWidget(mainWidget);
  treeWidget->setMinimumWidth(210);
  QBoxLayout *top = new QBoxLayout(treeWidget, QBoxLayout::TopToBottom);
  QGridLayout *grid = new QGridLayout(2,1);
  top->addLayout(grid);
         
  TabWidget2 = new QTabWidget(mainWidget, "TabWidget2" );
  
  tab = new QWidget( TabWidget2, "tab" );
  TabWidget2->insertTab( tab, i18n( "Info" ) );
  trafficShaperMonitor();
  
  tab_two = new QTabWidget( TabWidget2, "tab_two" );
  TabWidget2->insertTab( tab_two, i18n( "Create qdisc/class" ) );

  tab_three = new QWidget( TabWidget2, "tab_three" );
  TabWidget2->insertTab( tab_three, i18n( "Create filter" ) );
  trafficFilter();

  tab_four = new QWidget( TabWidget2, "tab_four" );
  TabWidget2->insertTab( tab_four, i18n( "Delete object" ) );
  deleteShaper();
  
  tab_five = new QWidget( TabWidget2, "tab_five" );
  TabWidget2->insertTab( tab_five, i18n( "Ingress qdisc" ) );
  ingressShaper();
  
  tab_1 = new QWidget( TabWidget2, "tab_1" );
  tab_two->insertTab( tab_1, i18n( "CBQ" ) );
  trafficShaper();

  tab_7 = new QWidget( TabWidget2, "tab_7" );
  tab_two->insertTab( tab_7, i18n( "DSMARK" ) );
  dsmarkShaper();
  
  tab_2 = new QWidget( TabWidget2, "tab_2" );
  tab_two->insertTab( tab_2, i18n( "PFIFO" ) );
  pfifoShaper();

  tab_3 = new QWidget( TabWidget2, "tab_3" );
  tab_two->insertTab( tab_3, i18n( "PRIO" ) );
  prioShaper();

  tab_4 = new QWidget( TabWidget2, "tab_4" );
  tab_two->insertTab( tab_4, i18n( "RED" ) );
  redShaper();

  tab_5 = new QWidget( TabWidget2, "tab_5" );
  tab_two->insertTab( tab_5, i18n( "SFQ" ) );
  sfqShaper();

  tab_6 = new QWidget( TabWidget2, "tab_6" );
  tab_two->insertTab( tab_6, i18n( "TBF" ) );
  tbfShaper();

  messageLog = new QListBox(mainWidget);
  messageLog->setMinimumSize(400, 80);
    
  grid2->addMultiCellWidget(TabWidget2,0,8,2,2);
  grid2->addMultiCellWidget(messageLog,9,10,2,2);
  grid2->addMultiCellWidget(treeWidget,0,10,0,1);

  connect(TabWidget2,SIGNAL(currentChanged(QWidget *)), SLOT(tabChanged(QWidget *)));

  QWhatsThis::add (messageLog, i18n("Standard output."));
  QWhatsThis::add (treeWidget, i18n("Current QoS configuration. Select object and click the right mouse button."));                   

  mainWidget->setBaseSize(mainWidget->sizeHint().width()-100, mainWidget->sizeHint().height()+20);
  mainWidget->show();       
  setCentralWidget(mainWidget);
  
  tcdev = 0;
  listinfo.clear();
  subqdiscs.clear();
  startMonitorProcess();  // create QoS Tree
};


// updating widgets
void Ktctool::setupKtctoolWidget2() {
       
  treeWidget = new QWidget(mainWidget);
  treeWidget->setMinimumWidth(210);
  QBoxLayout *top = new QBoxLayout(treeWidget, QBoxLayout::TopToBottom);
  QGridLayout *grid = new QGridLayout(2,1);
  top->addLayout(grid);
        
  ListViews *listView = new ListViews(treeWidget, "Listview", this);
  listView->setMinimumWidth(210);
  grid->addMultiCellWidget(listView,0,2,0,1);
  
  grid2->addMultiCellWidget(treeWidget,0,10,0,1);
  treeWidget->show();
  
};


// tab change, refresh if delete and update classes if filter
void Ktctool::tabChanged(QWidget *target) {
  
  int newTab = TabWidget2->indexOf(target);     
  if (newTab == 3) startdeleteShaper();
  if (newTab == 2) startclassShaper();
};
